// KX_AVR
// version 0.6 Copyright (C) 2005-2009 by Yasuo Kuwahara

//`define MEGA
//`define ELPM

module kx_avr_core(clk, reset, valid, pc, inst_valid, inst, intvec,
`ifdef TRACE
	tracedata,
`endif
	adr, we, data_in, data_in_ram, data_out, 
	id_break, id_sleep, id_wdr, id_spm, spm_sw, spm_data);
input clk, reset, valid, spm_sw;
input [15:0] inst;
input [5:0] intvec;
input [7:0] data_in, data_in_ram;
output [15:0] pc;
output [15:0] adr;
output we, inst_valid, id_break, id_sleep, id_spm, id_wdr;
output [7:0] data_out;
output [15:0] spm_data;
`ifdef TRACE
output [`TRACEMSB:0] tracedata;
`endif
`ifdef EPGM
parameter IACCS_MSB = 3;
`else
parameter IACCS_MSB = 2;
`endif
wire w_rjmprcall, w_ijmpicall, i_jmpcall1, i_ret1, i_ret2, i_lss, i_adiwsbiw;
wire t_lpm, lpm, force_nop, force_nop_i, iv, taken;
wire [7:0] inst_disp = { inst[9], inst[9:3] };
reg [7:0] disp = 0;
wire [7:0] disp_t, disp_a, disp_d;
wire [7:0] disp_c;
assign disp_c[0] = 0;
assign disp_a = inst_disp;
MUXCY muxcy_disp0(.S(disp_t[0]), .DI(disp_a[0]), .CI(disp_c[0]), .O(disp_c[0 + 1]));
XORCY xorcy_disp0(.LI(disp_t[0]), .CI(disp_c[0]), .O(disp_d[0]));
MUXCY muxcy_disp1(.S(disp_t[1]), .DI(disp_a[1]), .CI(disp_c[1]), .O(disp_c[1 + 1]));
XORCY xorcy_disp1(.LI(disp_t[1]), .CI(disp_c[1]), .O(disp_d[1]));
MUXCY muxcy_disp2(.S(disp_t[2]), .DI(disp_a[2]), .CI(disp_c[2]), .O(disp_c[2 + 1]));
XORCY xorcy_disp2(.LI(disp_t[2]), .CI(disp_c[2]), .O(disp_d[2]));
MUXCY muxcy_disp3(.S(disp_t[3]), .DI(disp_a[3]), .CI(disp_c[3]), .O(disp_c[3 + 1]));
XORCY xorcy_disp3(.LI(disp_t[3]), .CI(disp_c[3]), .O(disp_d[3]));
MUXCY muxcy_disp4(.S(disp_t[4]), .DI(disp_a[4]), .CI(disp_c[4]), .O(disp_c[4 + 1]));
XORCY xorcy_disp4(.LI(disp_t[4]), .CI(disp_c[4]), .O(disp_d[4]));
MUXCY muxcy_disp5(.S(disp_t[5]), .DI(disp_a[5]), .CI(disp_c[5]), .O(disp_c[5 + 1]));
XORCY xorcy_disp5(.LI(disp_t[5]), .CI(disp_c[5]), .O(disp_d[5]));
MUXCY muxcy_disp6(.S(disp_t[6]), .DI(disp_a[6]), .CI(disp_c[6]), .O(disp_c[6 + 1]));
XORCY xorcy_disp6(.LI(disp_t[6]), .CI(disp_c[6]), .O(disp_d[6]));
MUXCY muxcy_disp7(.S(disp_t[7]), .DI(disp_a[7]), .CI(disp_c[7]), .O());
XORCY xorcy_disp7(.LI(disp_t[7]), .CI(disp_c[7]), .O(disp_d[7]));
always @(posedge clk)
	if (~iv & valid) disp <= 0;
	else if (valid) disp <= disp_d;
assign disp_t = ~inst_disp;
wire [15:0] disp_e = {{ 15 { disp[7] }}, disp };
reg [15:0] pcreg = 0;
wire [15:0] pcdisp_t, pcdisp_a, pcdisp;
wire [15:0] pcdisp_c;
assign pcdisp_c[0] = 0;
assign pcdisp_a = pcreg;
MUXCY muxcy_pcdisp0(.S(pcdisp_t[0]), .DI(pcdisp_a[0]), .CI(pcdisp_c[0]), .O(pcdisp_c[0 + 1]));
XORCY xorcy_pcdisp0(.LI(pcdisp_t[0]), .CI(pcdisp_c[0]), .O(pcdisp[0]));
MUXCY muxcy_pcdisp1(.S(pcdisp_t[1]), .DI(pcdisp_a[1]), .CI(pcdisp_c[1]), .O(pcdisp_c[1 + 1]));
XORCY xorcy_pcdisp1(.LI(pcdisp_t[1]), .CI(pcdisp_c[1]), .O(pcdisp[1]));
MUXCY muxcy_pcdisp2(.S(pcdisp_t[2]), .DI(pcdisp_a[2]), .CI(pcdisp_c[2]), .O(pcdisp_c[2 + 1]));
XORCY xorcy_pcdisp2(.LI(pcdisp_t[2]), .CI(pcdisp_c[2]), .O(pcdisp[2]));
MUXCY muxcy_pcdisp3(.S(pcdisp_t[3]), .DI(pcdisp_a[3]), .CI(pcdisp_c[3]), .O(pcdisp_c[3 + 1]));
XORCY xorcy_pcdisp3(.LI(pcdisp_t[3]), .CI(pcdisp_c[3]), .O(pcdisp[3]));
MUXCY muxcy_pcdisp4(.S(pcdisp_t[4]), .DI(pcdisp_a[4]), .CI(pcdisp_c[4]), .O(pcdisp_c[4 + 1]));
XORCY xorcy_pcdisp4(.LI(pcdisp_t[4]), .CI(pcdisp_c[4]), .O(pcdisp[4]));
MUXCY muxcy_pcdisp5(.S(pcdisp_t[5]), .DI(pcdisp_a[5]), .CI(pcdisp_c[5]), .O(pcdisp_c[5 + 1]));
XORCY xorcy_pcdisp5(.LI(pcdisp_t[5]), .CI(pcdisp_c[5]), .O(pcdisp[5]));
MUXCY muxcy_pcdisp6(.S(pcdisp_t[6]), .DI(pcdisp_a[6]), .CI(pcdisp_c[6]), .O(pcdisp_c[6 + 1]));
XORCY xorcy_pcdisp6(.LI(pcdisp_t[6]), .CI(pcdisp_c[6]), .O(pcdisp[6]));
MUXCY muxcy_pcdisp7(.S(pcdisp_t[7]), .DI(pcdisp_a[7]), .CI(pcdisp_c[7]), .O(pcdisp_c[7 + 1]));
XORCY xorcy_pcdisp7(.LI(pcdisp_t[7]), .CI(pcdisp_c[7]), .O(pcdisp[7]));
MUXCY muxcy_pcdisp8(.S(pcdisp_t[8]), .DI(pcdisp_a[8]), .CI(pcdisp_c[8]), .O(pcdisp_c[8 + 1]));
XORCY xorcy_pcdisp8(.LI(pcdisp_t[8]), .CI(pcdisp_c[8]), .O(pcdisp[8]));
MUXCY muxcy_pcdisp9(.S(pcdisp_t[9]), .DI(pcdisp_a[9]), .CI(pcdisp_c[9]), .O(pcdisp_c[9 + 1]));
XORCY xorcy_pcdisp9(.LI(pcdisp_t[9]), .CI(pcdisp_c[9]), .O(pcdisp[9]));
MUXCY muxcy_pcdisp10(.S(pcdisp_t[10]), .DI(pcdisp_a[10]), .CI(pcdisp_c[10]), .O(pcdisp_c[10 + 1]));
XORCY xorcy_pcdisp10(.LI(pcdisp_t[10]), .CI(pcdisp_c[10]), .O(pcdisp[10]));
MUXCY muxcy_pcdisp11(.S(pcdisp_t[11]), .DI(pcdisp_a[11]), .CI(pcdisp_c[11]), .O(pcdisp_c[11 + 1]));
XORCY xorcy_pcdisp11(.LI(pcdisp_t[11]), .CI(pcdisp_c[11]), .O(pcdisp[11]));
MUXCY muxcy_pcdisp12(.S(pcdisp_t[12]), .DI(pcdisp_a[12]), .CI(pcdisp_c[12]), .O(pcdisp_c[12 + 1]));
XORCY xorcy_pcdisp12(.LI(pcdisp_t[12]), .CI(pcdisp_c[12]), .O(pcdisp[12]));
MUXCY muxcy_pcdisp13(.S(pcdisp_t[13]), .DI(pcdisp_a[13]), .CI(pcdisp_c[13]), .O(pcdisp_c[13 + 1]));
XORCY xorcy_pcdisp13(.LI(pcdisp_t[13]), .CI(pcdisp_c[13]), .O(pcdisp[13]));
MUXCY muxcy_pcdisp14(.S(pcdisp_t[14]), .DI(pcdisp_a[14]), .CI(pcdisp_c[14]), .O(pcdisp_c[14 + 1]));
XORCY xorcy_pcdisp14(.LI(pcdisp_t[14]), .CI(pcdisp_c[14]), .O(pcdisp[14]));
MUXCY muxcy_pcdisp15(.S(pcdisp_t[15]), .DI(pcdisp_a[15]), .CI(pcdisp_c[15]), .O());
XORCY xorcy_pcdisp15(.LI(pcdisp_t[15]), .CI(pcdisp_c[15]), .O(pcdisp[15]));
LUT3 LUT3_pcdisp0(.I2(taken), .I1(disp_e[0]), .I0(pcreg[0]), .O(pcdisp_t[0]));
defparam LUT3_pcdisp0.INIT = 'h6a;
LUT3 LUT3_pcdisp1(.I2(taken), .I1(disp_e[1]), .I0(pcreg[1]), .O(pcdisp_t[1]));
defparam LUT3_pcdisp1.INIT = 'h6a;
LUT3 LUT3_pcdisp2(.I2(taken), .I1(disp_e[2]), .I0(pcreg[2]), .O(pcdisp_t[2]));
defparam LUT3_pcdisp2.INIT = 'h6a;
LUT3 LUT3_pcdisp3(.I2(taken), .I1(disp_e[3]), .I0(pcreg[3]), .O(pcdisp_t[3]));
defparam LUT3_pcdisp3.INIT = 'h6a;
LUT3 LUT3_pcdisp4(.I2(taken), .I1(disp_e[4]), .I0(pcreg[4]), .O(pcdisp_t[4]));
defparam LUT3_pcdisp4.INIT = 'h6a;
LUT3 LUT3_pcdisp5(.I2(taken), .I1(disp_e[5]), .I0(pcreg[5]), .O(pcdisp_t[5]));
defparam LUT3_pcdisp5.INIT = 'h6a;
LUT3 LUT3_pcdisp6(.I2(taken), .I1(disp_e[6]), .I0(pcreg[6]), .O(pcdisp_t[6]));
defparam LUT3_pcdisp6.INIT = 'h6a;
LUT3 LUT3_pcdisp7(.I2(taken), .I1(disp_e[7]), .I0(pcreg[7]), .O(pcdisp_t[7]));
defparam LUT3_pcdisp7.INIT = 'h6a;
LUT3 LUT3_pcdisp8(.I2(taken), .I1(disp_e[8]), .I0(pcreg[8]), .O(pcdisp_t[8]));
defparam LUT3_pcdisp8.INIT = 'h6a;
LUT3 LUT3_pcdisp9(.I2(taken), .I1(disp_e[9]), .I0(pcreg[9]), .O(pcdisp_t[9]));
defparam LUT3_pcdisp9.INIT = 'h6a;
LUT3 LUT3_pcdisp10(.I2(taken), .I1(disp_e[10]), .I0(pcreg[10]), .O(pcdisp_t[10]));
defparam LUT3_pcdisp10.INIT = 'h6a;
LUT3 LUT3_pcdisp11(.I2(taken), .I1(disp_e[11]), .I0(pcreg[11]), .O(pcdisp_t[11]));
defparam LUT3_pcdisp11.INIT = 'h6a;
LUT3 LUT3_pcdisp12(.I2(taken), .I1(disp_e[12]), .I0(pcreg[12]), .O(pcdisp_t[12]));
defparam LUT3_pcdisp12.INIT = 'h6a;
LUT3 LUT3_pcdisp13(.I2(taken), .I1(disp_e[13]), .I0(pcreg[13]), .O(pcdisp_t[13]));
defparam LUT3_pcdisp13.INIT = 'h6a;
LUT3 LUT3_pcdisp14(.I2(taken), .I1(disp_e[14]), .I0(pcreg[14]), .O(pcdisp_t[14]));
defparam LUT3_pcdisp14.INIT = 'h6a;
LUT3 LUT3_pcdisp15(.I2(taken), .I1(disp_e[15]), .I0(pcreg[15]), .O(pcdisp_t[15]));
defparam LUT3_pcdisp15.INIT = 'h6a;
wire [15:0] pcofs = {{ 4 { inst[11] }}, inst[11:0] };
wire [15:0] pcadd_t, pcadd_a, pcadd;
wire [15:0] pcadd_c;
assign pcadd_c[0] = ~w_rjmprcall;
assign pcadd_a = pcdisp;
MUXCY muxcy_pcadd0(.S(pcadd_t[0]), .DI(pcadd_a[0]), .CI(pcadd_c[0]), .O(pcadd_c[0 + 1]));
XORCY xorcy_pcadd0(.LI(pcadd_t[0]), .CI(pcadd_c[0]), .O(pcadd[0]));
MUXCY muxcy_pcadd1(.S(pcadd_t[1]), .DI(pcadd_a[1]), .CI(pcadd_c[1]), .O(pcadd_c[1 + 1]));
XORCY xorcy_pcadd1(.LI(pcadd_t[1]), .CI(pcadd_c[1]), .O(pcadd[1]));
MUXCY muxcy_pcadd2(.S(pcadd_t[2]), .DI(pcadd_a[2]), .CI(pcadd_c[2]), .O(pcadd_c[2 + 1]));
XORCY xorcy_pcadd2(.LI(pcadd_t[2]), .CI(pcadd_c[2]), .O(pcadd[2]));
MUXCY muxcy_pcadd3(.S(pcadd_t[3]), .DI(pcadd_a[3]), .CI(pcadd_c[3]), .O(pcadd_c[3 + 1]));
XORCY xorcy_pcadd3(.LI(pcadd_t[3]), .CI(pcadd_c[3]), .O(pcadd[3]));
MUXCY muxcy_pcadd4(.S(pcadd_t[4]), .DI(pcadd_a[4]), .CI(pcadd_c[4]), .O(pcadd_c[4 + 1]));
XORCY xorcy_pcadd4(.LI(pcadd_t[4]), .CI(pcadd_c[4]), .O(pcadd[4]));
MUXCY muxcy_pcadd5(.S(pcadd_t[5]), .DI(pcadd_a[5]), .CI(pcadd_c[5]), .O(pcadd_c[5 + 1]));
XORCY xorcy_pcadd5(.LI(pcadd_t[5]), .CI(pcadd_c[5]), .O(pcadd[5]));
MUXCY muxcy_pcadd6(.S(pcadd_t[6]), .DI(pcadd_a[6]), .CI(pcadd_c[6]), .O(pcadd_c[6 + 1]));
XORCY xorcy_pcadd6(.LI(pcadd_t[6]), .CI(pcadd_c[6]), .O(pcadd[6]));
MUXCY muxcy_pcadd7(.S(pcadd_t[7]), .DI(pcadd_a[7]), .CI(pcadd_c[7]), .O(pcadd_c[7 + 1]));
XORCY xorcy_pcadd7(.LI(pcadd_t[7]), .CI(pcadd_c[7]), .O(pcadd[7]));
MUXCY muxcy_pcadd8(.S(pcadd_t[8]), .DI(pcadd_a[8]), .CI(pcadd_c[8]), .O(pcadd_c[8 + 1]));
XORCY xorcy_pcadd8(.LI(pcadd_t[8]), .CI(pcadd_c[8]), .O(pcadd[8]));
MUXCY muxcy_pcadd9(.S(pcadd_t[9]), .DI(pcadd_a[9]), .CI(pcadd_c[9]), .O(pcadd_c[9 + 1]));
XORCY xorcy_pcadd9(.LI(pcadd_t[9]), .CI(pcadd_c[9]), .O(pcadd[9]));
MUXCY muxcy_pcadd10(.S(pcadd_t[10]), .DI(pcadd_a[10]), .CI(pcadd_c[10]), .O(pcadd_c[10 + 1]));
XORCY xorcy_pcadd10(.LI(pcadd_t[10]), .CI(pcadd_c[10]), .O(pcadd[10]));
MUXCY muxcy_pcadd11(.S(pcadd_t[11]), .DI(pcadd_a[11]), .CI(pcadd_c[11]), .O(pcadd_c[11 + 1]));
XORCY xorcy_pcadd11(.LI(pcadd_t[11]), .CI(pcadd_c[11]), .O(pcadd[11]));
MUXCY muxcy_pcadd12(.S(pcadd_t[12]), .DI(pcadd_a[12]), .CI(pcadd_c[12]), .O(pcadd_c[12 + 1]));
XORCY xorcy_pcadd12(.LI(pcadd_t[12]), .CI(pcadd_c[12]), .O(pcadd[12]));
MUXCY muxcy_pcadd13(.S(pcadd_t[13]), .DI(pcadd_a[13]), .CI(pcadd_c[13]), .O(pcadd_c[13 + 1]));
XORCY xorcy_pcadd13(.LI(pcadd_t[13]), .CI(pcadd_c[13]), .O(pcadd[13]));
MUXCY muxcy_pcadd14(.S(pcadd_t[14]), .DI(pcadd_a[14]), .CI(pcadd_c[14]), .O(pcadd_c[14 + 1]));
XORCY xorcy_pcadd14(.LI(pcadd_t[14]), .CI(pcadd_c[14]), .O(pcadd[14]));
MUXCY muxcy_pcadd15(.S(pcadd_t[15]), .DI(pcadd_a[15]), .CI(pcadd_c[15]), .O());
XORCY xorcy_pcadd15(.LI(pcadd_t[15]), .CI(pcadd_c[15]), .O(pcadd[15]));
LUT3 LUT3_pcadd0(.I2(w_rjmprcall), .I1(pcofs[0]), .I0(pcdisp[0]), .O(pcadd_t[0]));
defparam LUT3_pcadd0.INIT = 'h6a;
LUT3 LUT3_pcadd1(.I2(w_rjmprcall), .I1(pcofs[1]), .I0(pcdisp[1]), .O(pcadd_t[1]));
defparam LUT3_pcadd1.INIT = 'h6a;
LUT3 LUT3_pcadd2(.I2(w_rjmprcall), .I1(pcofs[2]), .I0(pcdisp[2]), .O(pcadd_t[2]));
defparam LUT3_pcadd2.INIT = 'h6a;
LUT3 LUT3_pcadd3(.I2(w_rjmprcall), .I1(pcofs[3]), .I0(pcdisp[3]), .O(pcadd_t[3]));
defparam LUT3_pcadd3.INIT = 'h6a;
LUT3 LUT3_pcadd4(.I2(w_rjmprcall), .I1(pcofs[4]), .I0(pcdisp[4]), .O(pcadd_t[4]));
defparam LUT3_pcadd4.INIT = 'h6a;
LUT3 LUT3_pcadd5(.I2(w_rjmprcall), .I1(pcofs[5]), .I0(pcdisp[5]), .O(pcadd_t[5]));
defparam LUT3_pcadd5.INIT = 'h6a;
LUT3 LUT3_pcadd6(.I2(w_rjmprcall), .I1(pcofs[6]), .I0(pcdisp[6]), .O(pcadd_t[6]));
defparam LUT3_pcadd6.INIT = 'h6a;
LUT3 LUT3_pcadd7(.I2(w_rjmprcall), .I1(pcofs[7]), .I0(pcdisp[7]), .O(pcadd_t[7]));
defparam LUT3_pcadd7.INIT = 'h6a;
LUT3 LUT3_pcadd8(.I2(w_rjmprcall), .I1(pcofs[8]), .I0(pcdisp[8]), .O(pcadd_t[8]));
defparam LUT3_pcadd8.INIT = 'h6a;
LUT3 LUT3_pcadd9(.I2(w_rjmprcall), .I1(pcofs[9]), .I0(pcdisp[9]), .O(pcadd_t[9]));
defparam LUT3_pcadd9.INIT = 'h6a;
LUT3 LUT3_pcadd10(.I2(w_rjmprcall), .I1(pcofs[10]), .I0(pcdisp[10]), .O(pcadd_t[10]));
defparam LUT3_pcadd10.INIT = 'h6a;
LUT3 LUT3_pcadd11(.I2(w_rjmprcall), .I1(pcofs[11]), .I0(pcdisp[11]), .O(pcadd_t[11]));
defparam LUT3_pcadd11.INIT = 'h6a;
LUT3 LUT3_pcadd12(.I2(w_rjmprcall), .I1(pcofs[12]), .I0(pcdisp[12]), .O(pcadd_t[12]));
defparam LUT3_pcadd12.INIT = 'h6a;
LUT3 LUT3_pcadd13(.I2(w_rjmprcall), .I1(pcofs[13]), .I0(pcdisp[13]), .O(pcadd_t[13]));
defparam LUT3_pcadd13.INIT = 'h6a;
LUT3 LUT3_pcadd14(.I2(w_rjmprcall), .I1(pcofs[14]), .I0(pcdisp[14]), .O(pcadd_t[14]));
defparam LUT3_pcadd14.INIT = 'h6a;
LUT3 LUT3_pcadd15(.I2(w_rjmprcall), .I1(pcofs[15]), .I0(pcdisp[15]), .O(pcadd_t[15]));
defparam LUT3_pcadd15.INIT = 'h6a;
wire [7:0] sreg;
wire iacc0 = ~(force_nop_i | lpm | i_lss | i_adiwsbiw) & sreg[7] & |intvec;
wire [15:0] forward_z; 
reg [IACCS_MSB:0] iaccs = 0;
always @(posedge clk) 
	if (reset) iaccs <= 0;
	else if (valid) iaccs <= { iaccs[IACCS_MSB-1:0], iacc0 };
wire iacc1 = iaccs[1:0] == 'b01;
wire iacc2 = iaccs[2:1] == 'b01;
`ifdef EPGM
wire iacc2e = iaccs[3:2] == 'b01;
reg [15-16:0] pch_ret = 0;
reg [7:0] pcm_ret = 0;
wire i_ret3;
always @(posedge clk) if (valid & i_ret3) pcm_ret <= data_in_ram;
always @(posedge clk) if (valid & i_ret1) pch_ret <= data_in_ram;
wire [15-8:0] pc_ret = { pch_ret, pcm_ret };
wire [15-16:0] forward_eind;
wire [15:0] iadr = { forward_eind, forward_z };
`else
wire iacc2e = iacc2;
reg [15-8:0] pcm_ret = 0;
always @(posedge clk) if (valid & i_ret1) pcm_ret <= data_in_ram;
wire [15-8:0] pc_ret = pcm_ret;
wire [15:0] iadr = forward_z;
`endif
wire [15:0] pc0, pc1, pc_d;
reg [11:0] ix = 0;
wire [15:0] jmpcalladr = { ix[8:4], ix[0], inst };
LUT3 LUT3_pc00(.I2(w_ijmpicall), .I1(iadr[0]), .I0(pcadd[0]), .O(pc0[0]));
defparam LUT3_pc00.INIT = 'hca;
LUT3 LUT3_pc01(.I2(w_ijmpicall), .I1(iadr[1]), .I0(pcadd[1]), .O(pc0[1]));
defparam LUT3_pc01.INIT = 'hca;
LUT3 LUT3_pc02(.I2(w_ijmpicall), .I1(iadr[2]), .I0(pcadd[2]), .O(pc0[2]));
defparam LUT3_pc02.INIT = 'hca;
LUT3 LUT3_pc03(.I2(w_ijmpicall), .I1(iadr[3]), .I0(pcadd[3]), .O(pc0[3]));
defparam LUT3_pc03.INIT = 'hca;
LUT3 LUT3_pc04(.I2(w_ijmpicall), .I1(iadr[4]), .I0(pcadd[4]), .O(pc0[4]));
defparam LUT3_pc04.INIT = 'hca;
LUT3 LUT3_pc05(.I2(w_ijmpicall), .I1(iadr[5]), .I0(pcadd[5]), .O(pc0[5]));
defparam LUT3_pc05.INIT = 'hca;
LUT3 LUT3_pc06(.I2(w_ijmpicall), .I1(iadr[6]), .I0(pcadd[6]), .O(pc0[6]));
defparam LUT3_pc06.INIT = 'hca;
LUT3 LUT3_pc07(.I2(w_ijmpicall), .I1(iadr[7]), .I0(pcadd[7]), .O(pc0[7]));
defparam LUT3_pc07.INIT = 'hca;
LUT3 LUT3_pc08(.I2(w_ijmpicall), .I1(iadr[8]), .I0(pcadd[8]), .O(pc0[8]));
defparam LUT3_pc08.INIT = 'hca;
LUT3 LUT3_pc09(.I2(w_ijmpicall), .I1(iadr[9]), .I0(pcadd[9]), .O(pc0[9]));
defparam LUT3_pc09.INIT = 'hca;
LUT3 LUT3_pc010(.I2(w_ijmpicall), .I1(iadr[10]), .I0(pcadd[10]), .O(pc0[10]));
defparam LUT3_pc010.INIT = 'hca;
LUT3 LUT3_pc011(.I2(w_ijmpicall), .I1(iadr[11]), .I0(pcadd[11]), .O(pc0[11]));
defparam LUT3_pc011.INIT = 'hca;
LUT3 LUT3_pc012(.I2(w_ijmpicall), .I1(iadr[12]), .I0(pcadd[12]), .O(pc0[12]));
defparam LUT3_pc012.INIT = 'hca;
LUT3 LUT3_pc013(.I2(w_ijmpicall), .I1(iadr[13]), .I0(pcadd[13]), .O(pc0[13]));
defparam LUT3_pc013.INIT = 'hca;
LUT3 LUT3_pc014(.I2(w_ijmpicall), .I1(iadr[14]), .I0(pcadd[14]), .O(pc0[14]));
defparam LUT3_pc014.INIT = 'hca;
LUT3 LUT3_pc015(.I2(w_ijmpicall), .I1(iadr[15]), .I0(pcadd[15]), .O(pc0[15]));
defparam LUT3_pc015.INIT = 'hca;
LUT4 lut4_pc10(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[0]), .I0(jmpcalladr[0]), .O(pc1[0]));
defparam lut4_pc10.INIT = 'hca;
LUT4 lut4_pc11(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[1]), .I0(iacc2e ? intvec[1 - 1] : jmpcalladr[1]), .O(pc1[1]));
defparam lut4_pc11.INIT = 'haaca;
LUT4 lut4_pc12(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[2]), .I0(iacc2e ? intvec[2 - 1] : jmpcalladr[2]), .O(pc1[2]));
defparam lut4_pc12.INIT = 'haaca;
LUT4 lut4_pc13(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[3]), .I0(iacc2e ? intvec[3 - 1] : jmpcalladr[3]), .O(pc1[3]));
defparam lut4_pc13.INIT = 'haaca;
LUT4 lut4_pc14(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[4]), .I0(iacc2e ? intvec[4 - 1] : jmpcalladr[4]), .O(pc1[4]));
defparam lut4_pc14.INIT = 'haaca;
LUT4 lut4_pc15(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[5]), .I0(iacc2e ? intvec[5 - 1] : jmpcalladr[5]), .O(pc1[5]));
defparam lut4_pc15.INIT = 'haaca;
LUT4 lut4_pc16(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[6]), .I0(iacc2e ? intvec[6 - 1] : jmpcalladr[6]), .O(pc1[6]));
defparam lut4_pc16.INIT = 'haaca;
LUT4 lut4_pc17(.I3(iacc2e), .I2(i_ret2), .I1(data_in_ram[7]), .I0(jmpcalladr[7]), .O(pc1[7]));
defparam lut4_pc17.INIT = 'hca;
LUT4 LUT4_pc0(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[0]), .I0(jmpcalladr[0 + 8]), .O(pc1[0 + 8]));
defparam LUT4_pc0.INIT = 'hca;
LUT4 LUT4_pc1(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[1]), .I0(jmpcalladr[1 + 8]), .O(pc1[1 + 8]));
defparam LUT4_pc1.INIT = 'hca;
LUT4 LUT4_pc2(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[2]), .I0(jmpcalladr[2 + 8]), .O(pc1[2 + 8]));
defparam LUT4_pc2.INIT = 'hca;
LUT4 LUT4_pc3(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[3]), .I0(jmpcalladr[3 + 8]), .O(pc1[3 + 8]));
defparam LUT4_pc3.INIT = 'hca;
LUT4 LUT4_pc4(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[4]), .I0(jmpcalladr[4 + 8]), .O(pc1[4 + 8]));
defparam LUT4_pc4.INIT = 'hca;
LUT4 LUT4_pc5(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[5]), .I0(jmpcalladr[5 + 8]), .O(pc1[5 + 8]));
defparam LUT4_pc5.INIT = 'hca;
LUT4 LUT4_pc6(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[6]), .I0(jmpcalladr[6 + 8]), .O(pc1[6 + 8]));
defparam LUT4_pc6.INIT = 'hca;
LUT4 LUT4_pc7(.I3(iacc2e), .I2(i_ret2), .I1(pc_ret[7]), .I0(jmpcalladr[7 + 8]), .O(pc1[7 + 8]));
defparam LUT4_pc7.INIT = 'hca;
wire sel_pc = i_jmpcall1 | i_ret2 | iacc2e;
MUXF5 MUXF5_pc0(.S(sel_pc), .I1(pc1[0]), .I0(pc0[0]), .O(pc_d[0]));
MUXF5 MUXF5_pc1(.S(sel_pc), .I1(pc1[1]), .I0(pc0[1]), .O(pc_d[1]));
MUXF5 MUXF5_pc2(.S(sel_pc), .I1(pc1[2]), .I0(pc0[2]), .O(pc_d[2]));
MUXF5 MUXF5_pc3(.S(sel_pc), .I1(pc1[3]), .I0(pc0[3]), .O(pc_d[3]));
MUXF5 MUXF5_pc4(.S(sel_pc), .I1(pc1[4]), .I0(pc0[4]), .O(pc_d[4]));
MUXF5 MUXF5_pc5(.S(sel_pc), .I1(pc1[5]), .I0(pc0[5]), .O(pc_d[5]));
MUXF5 MUXF5_pc6(.S(sel_pc), .I1(pc1[6]), .I0(pc0[6]), .O(pc_d[6]));
MUXF5 MUXF5_pc7(.S(sel_pc), .I1(pc1[7]), .I0(pc0[7]), .O(pc_d[7]));
MUXF5 MUXF5_pc8(.S(sel_pc), .I1(pc1[8]), .I0(pc0[8]), .O(pc_d[8]));
MUXF5 MUXF5_pc9(.S(sel_pc), .I1(pc1[9]), .I0(pc0[9]), .O(pc_d[9]));
MUXF5 MUXF5_pc10(.S(sel_pc), .I1(pc1[10]), .I0(pc0[10]), .O(pc_d[10]));
MUXF5 MUXF5_pc11(.S(sel_pc), .I1(pc1[11]), .I0(pc0[11]), .O(pc_d[11]));
MUXF5 MUXF5_pc12(.S(sel_pc), .I1(pc1[12]), .I0(pc0[12]), .O(pc_d[12]));
MUXF5 MUXF5_pc13(.S(sel_pc), .I1(pc1[13]), .I0(pc0[13]), .O(pc_d[13]));
MUXF5 MUXF5_pc14(.S(sel_pc), .I1(pc1[14]), .I0(pc0[14]), .O(pc_d[14]));
MUXF5 MUXF5_pc15(.S(sel_pc), .I1(pc1[15]), .I0(pc0[15]), .O(pc_d[15]));
wire pcsw = ~force_nop & t_lpm & ~lpm | spm_sw;
always @(posedge clk) 
	if (reset) pcreg <= 0;
	else if (valid & inst_valid & ~pcsw) pcreg <= pc_d;
`ifdef ELPM
wire [15-15:0] forward_rampz;
wire [15:0] pcz = { forward_rampz, forward_z[15:1] };
`else
wire [15:0] pcz = { 0, forward_z[15:1]};
`endif
assign pc = pcsw ? pcz : pcdisp;
wire i_lds, i_sts, i_call, i_ret, ls_e;
always @(posedge clk) 
	if (~iv & valid) ix <= 0;
	else if (valid) ix <= inst[11:0];
wire [1:0] state;
wire x_add = iv & inst[15:10] == 'b000011;
wire x_adc = iv & inst[15:10] == 'b000111;
wire x_adiwsbiw = iv & inst[15:9] == 'b1001011;
wire x_adiw = x_adiwsbiw & ~inst[8];
wire x_sub = iv & inst[15:10] == 'b000110;
wire x_subi = iv & inst[15:12] == 'b0101;
wire x_sbc = iv & inst[15:10] == 'b000010;
wire x_sbci = iv & inst[15:12] == 'b0100;
wire x_sbiw = x_adiwsbiw & inst[8];
wire x_and = iv & inst[15:10] == 'b001000;
wire x_andi = iv & inst[15:12] == 'b0111;
wire x_or = iv & inst[15:10] == 'b001010;
wire x_ori = iv & inst[15:12] == 'b0110;
wire x_eor = iv & inst[15:10] == 'b001001;
wire x_single = iv & inst[15:9] == 'b1001010;
wire x_comneg = x_single & inst[3:1] == 'b000;
wire x_com = x_comneg & ~inst[0];
wire x_neg = x_comneg & inst[0];
wire x_incdec = x_single & inst[2:1] == 'b01 & (inst[3] ^ inst[0]);
wire x_dec = x_incdec & inst[3];
wire x_rjmp = iv & inst[15:12] == 'b1100;
wire w_rjmp = ~force_nop & x_rjmp;
wire x_rcall = iv & inst[15:12] == 'b1101;
wire w_rcall = ~force_nop & x_rcall & ~state[0];
wire x_ijmp = iv & inst[15:5] == 'b10010100000 & inst[3:0] == 'b1001;
wire w_ijmp = ~force_nop & x_ijmp;
wire x_icall = iv & inst[15:5] == 'b10010101000 & inst[3:0] == 'b1001;
wire w_icall = (~force_nop & x_icall | iacc2) & ~state[0];
wire x_ret = iv & inst[15:5] == 'b10010101000 & inst[3:0] == 'b1000;
wire w_ret = ~force_nop & x_ret & ~state[0];
assign i_ret1 = i_ret & state == 1;
assign i_ret2 = i_ret & state == 2;
wire i_call1 = i_call & state == 1;
`ifdef EPGM
wire i_rcall1, i_icall1;
assign w_rjmprcall = w_rjmp | i_rcall1;
assign w_ijmpicall = w_ijmp | i_icall1;
wire i_call13 = i_call & state[0];
assign i_ret3 = i_ret & state == 3;
wire i_ret13 = i_ret1 | i_ret3;
`else
assign w_rjmprcall = w_rjmp | w_rcall;
assign w_ijmpicall = w_ijmp | w_icall;
wire i_call13 = i_call1;
wire i_ret13 = i_ret1;
`endif
wire x_reti = x_ret & inst[4];
wire x_cpse = iv & inst[15:10] == 'b000100;
wire x_cp = iv & inst[15:10] == 'b000101;
wire x_cpc = iv & inst[15:10] == 'b000001;
wire x_cpi = iv & inst[15:12] == 'b0011;
wire x_sbrc = iv & inst[15:9] == 'b1111110 & ~inst[3];
wire x_sbrs = iv & inst[15:9] == 'b1111111 & ~inst[3];
wire x_sbic = iv & inst[15:8] == 'b10011001;
wire x_sbis = iv & inst[15:8] == 'b10011011;
wire x_mov = iv & inst[15:10] == 'b001011;
wire x_movw = iv & inst[15:8] == 'b00000001;
wire x_ldi = iv & inst[15:12] == 'b1110;
wire x_ls = iv & inst[15:10] == 'b100100;
wire x_lsx = x_ls & inst[3:0] == 'b1100;
wire x_lsxp = x_ls & inst[3:0] == 'b1101;
wire x_lsmx = x_ls & inst[3:0] == 'b1110;
wire x_lsyp = x_ls & inst[3:0] == 'b1001;
wire x_lsmy = x_ls & inst[3:0] == 'b1010;
wire x_lsyd = iv & inst[15] & ~inst[14] & ~inst[12] & inst[3];
wire x_lszp = x_ls & inst[3:0] == 'b0001;
wire x_lsmz = x_ls & inst[3:0] == 'b0010;
wire x_lszd = iv & inst[15] & ~inst[14] & ~inst[12] & ~inst[3];
wire x_lss = x_ls & inst[3:0] == 'b0000;
LUT4 lut4_ls(.I3(inst[3]), .I2(inst[2]), .I1(inst[1]), .I0(inst[0]), .O(ls_e));
defparam lut4_ls.INIT = 'h7606;
wire x_load_t = x_ls & ~inst[9] & ls_e;
wire x_store_t = x_ls & inst[9] & ls_e;
wire x_ldyd = x_lsyd & ~inst[9];
wire x_ldzd = x_lszd & ~inst[9];
wire x_lpm = iv & inst[15:5] == 'b10010101110 & inst[3:0] == 'b1000;
wire x_lpmz = x_ls & ~inst[9] & inst[3:2] == 'b01 & ~inst[0];
wire x_lpmzp = x_ls & ~inst[9] & inst[3:2] == 'b01 & inst[0];
wire f_elpm = inst[10] ? inst[4] : inst[1];
assign t_lpm = x_lpm | x_lpmz | x_lpmzp;
wire x_spm = iv & inst == 'h95e8;
assign id_spm = ~force_nop & x_spm;
assign id_sleep = ~force_nop & iv & inst == 'h9588;
assign id_break = ~force_nop & iv & inst == 'h9598;
assign id_wdr = ~force_nop & iv & inst == 'h95a8;
wire x_load = x_load_t | x_ldyd | x_ldzd | i_lds;
wire x_styd = x_lsyd & inst[9];
wire x_stzd = x_lszd & inst[9];
wire x_store = x_store_t | x_styd | x_stzd | i_sts;
wire x_io = iv & inst[15:12] == 4'b1011;
wire x_in = x_io & ~inst[11];
wire x_out = x_io & inst[11];
wire x_push = x_ls & inst[9] & inst[3:0] == 'b1111;
wire x_pop = x_ls & ~inst[9] & inst[3:0] == 'b1111;
wire x_sbi = iv & inst[15:8] == 'b10011010;
wire x_cbi = iv & inst[15:8] == 'b10011000;
wire t_shift_right = x_single & inst[3:2] == 'b01 & |inst[1:0];
wire x_swap = x_single & inst[3:0] == 'b0010;
wire x_bclrbset = iv & inst[15:8] == 'b10010100 & inst[3:0] == 'b1000;
wire x_bclr = x_bclrbset & inst[7];
wire x_bst = iv & inst[15:9] == 'b1111101 & ~inst[3];
wire x_bld = iv & inst[15:9] == 'b1111100 & ~inst[3];
`ifdef MEGA
wire x_jmpcall = iv & inst[15:9] == 'b1001010 & inst[3:2] == 'b11;
wire i_jmpcall;
assign i_jmpcall1 = i_jmpcall & state == 1;
wire x_jmp = x_jmpcall & ~inst[1];
wire w_jmp = ~force_nop & x_jmp & ~state[0];
wire x_call = x_jmpcall & inst[1];
wire w_call = ~force_nop & x_call & ~state[0];
wire x_mul = iv & inst[15:10] == 'b100111;
wire x_muls = iv & inst[15:8] == 'b00000010;
wire x_mulother = iv & inst[15:8] == 'b00000011;
wire x_mulall = x_mul | x_muls | x_mulother;
wire x_mulsu = x_mulother & ~inst[7] & ~inst[3];
wire x_fmul = x_mulother & ~inst[7] & inst[3];
wire x_fmuls = x_mulother & inst[7] & ~inst[3];
wire x_fmulsu = x_mulother & inst[7] & inst[3];
`else
wire x_jmp = 0, w_jmp = 0, x_call = 0, w_call = 0;
assign i_jmpcall1 = 0;
wire x_mul = 0, x_muls = 0, x_mulother = 0, x_mulall = 0;
`endif
wire x_pushcall = x_push | x_rcall | x_icall | x_call | i_call13 | iacc2;
wire w_pushcall = ~force_nop & x_push | w_rcall | w_icall | w_call | i_call13;
assign inst_valid = ~(~force_nop & x_adiwsbiw & ~i_adiwsbiw | w_ret | i_ret13 | iacc0 & ~iaccs[1]);
wire i_lpmzp, i_branch, ix_bld, ix_com, ix_movw, ix_neg, ix_swap;
wire branch, alu_z, shift_right, skip_g, skip_flip, skip_double;
assign taken = i_branch & (sreg[ix[2:0]] ^ ix[10]);
wire skip = skip_g & (skip_flip ^ alu_z);
assign force_nop_i = branch | taken | skip | skip_double;
assign force_nop = ~reset & (force_nop_i | iacc0 & ~iaccs[0]);
wire reset_f = valid & force_nop;
FDE id00(.C(clk), .CE(valid), .D(~force_nop & (x_rjmp | x_ijmp) | w_jmp | w_rcall | w_icall | w_call | w_ret | i_ret | i_jmpcall1
`ifdef EPGM
	| i_rcall1 | i_icall1
`endif
), .Q(branch));
FDE id01(.C(clk), .CE(valid), .D(x_bld), .Q(ix_bld));
FDE id02(.C(clk), .CE(valid), .D(x_com), .Q(ix_com));
FDE id03(.C(clk), .CE(valid), .D(x_movw), .Q(ix_movw));
FDE id04(.C(clk), .CE(valid), .D(x_neg), .Q(ix_neg));
FDE id05(.C(clk), .CE(valid), .D(x_swap), .Q(ix_swap));
FDE id06(.C(clk), .CE(valid), .D(t_shift_right), .Q(shift_right));
FDE id07(.C(clk), .CE(valid & ~state[0]), .D(w_ret), .Q(i_ret));
FDE id08(.C(clk), .CE(valid), .D(skip & x_lss), .Q(skip_double));
FDRE id09(.C(clk), .R(reset_f), .CE(valid), .D(x_adiwsbiw & ~i_adiwsbiw), .Q(i_adiwsbiw));
FDRE id10(.C(clk), .R(reset_f), .CE(valid), .D(x_lss & ~i_lss), .Q(i_lss));
FDRE id11(.C(clk), .R(reset_f), .CE(valid), .D(x_lss & ~i_lds & ~inst[9]), .Q(i_lds));
FDRE id12(.C(clk), .R(reset_f), .CE(valid), .D(x_lss & ~i_sts & inst[9]), .Q(i_sts));
FDRE id13(.C(clk), .R(reset_f), .CE(valid), .D(x_lpmzp), .Q(i_lpmzp));
FDRE id14(.C(clk), .R(reset_f), .CE(valid), .D(x_cpse | x_sbic | x_sbis | x_sbrc | x_sbrs), .Q(skip_g));
FDE id15(.C(clk), .CE(valid), .D(x_sbis | x_sbrs), .Q(skip_flip));
FDRE id16(.C(clk), .R(reset_f), .CE(valid), .D(iv & inst[15:11] == 'b11110), .Q(i_branch));
FDRE id17(.C(clk), .R(reset_f), .CE(valid), .D(t_lpm), .Q(lpm));
FDE id18(.C(clk), .CE(valid & ~state[0]), .D(w_rcall | w_icall | w_call), .Q(i_call));
FDRE id19(.C(clk), .R(reset), .CE(valid), .D(~state[0] & (~force_nop & (x_rcall | x_icall | x_ret | x_call | x_jmp) | iacc2)
`ifdef EPGM
	| ~state[1] & (i_call | i_ret)
`endif
), .Q(state[0]));
FDRE id20(.C(clk), .R(reset), .CE(valid), .D(state[0] & (i_call | i_ret)), .Q(state[1]));
FDRE id21(.C(clk), .R(reset), .CE(valid), .D(~(~force_nop & (x_lss & ~i_lss | t_lpm) | iacc0 | iacc1 | iacc2 | iacc2e
`ifdef EPGM
	| i_call1
`endif
)), .Q(iv));
`ifdef MEGA
FDRE id22(.C(clk), .R(reset_f), .CE(valid), .D(x_jmpcall), .Q(i_jmpcall));
wire ix_mulall;
FDE id23(.C(clk), .CE(valid), .D(x_mulall), .Q(ix_mulall));
`else
wire ix_mulall = 0;
`endif
`ifdef EPGM
FDE id24(.C(clk), .CE(valid), .D(w_rcall), .Q(i_rcall1));
FDE id25(.C(clk), .CE(valid), .D(w_icall), .Q(i_icall1));
`endif
	function [4:0] arasel;
		input [2:0] sel;
		input [34:0] a;
		case (sel)
			0: arasel = a[4:0];
			1: arasel = a[9:5];
			2: arasel = a[14:10];
			3: arasel = a[19:15];
			4: arasel = a[24:20];
			5: arasel = a[29:25];
			default: arasel = a[34:30];
		endcase
	endfunction
wire upper_reg;
LUT4 lut4_upper_reg(.I3(inst[15]), .I2(inst[14]), .I1(inst[13]), .I0(inst[12]), .O(upper_reg));
defparam lut4_upper_reg.INIT = 'h40f8;
wire [4:0] ara0 = arasel({
	x_adiwsbiw | x_movw | x_spm,
	x_muls | x_mulother | x_spm,
	x_adiwsbiw | x_mulother | i_lss
}, {
	2'b11, inst[5:4], i_adiwsbiw,	
	inst[7:4], 1'b0,				
	2'b10, inst[6:4],				
	1'b1, inst[7:4],				
	ix[8:4],						
	inst[8] | upper_reg, inst[7:4]	
});
	function [15:0] arbsel;
		input [2:0] sel;
		input [127:0] a;
		case (sel)
			0: arbsel = a[15:0];
			1: arbsel = a[31:16];
			2: arbsel = a[47:32];
			3: arbsel = a[63:48];
			4: arbsel = a[79:64];
			5: arbsel = a[95:80];
			6: arbsel = a[111:96];
			7: arbsel = a[127:112];
		endcase
	endfunction
wire [15:0] arb00, arb0_0, arb0_2, arb0_3, arb0_4, arb0_5, arb0_6, arb0_7;
assign arb0_7 = { 2'b10, inst[2:0] };
assign arb0_6 = { 1'b1, inst[3:0] };
assign arb0_5 = { inst[10], ~inst[10], inst[9], inst[3:0] };
assign arb0_4 = { 1'b1, inst[7:3] };
assign arb0_3 = { inst[3:0], 1'b0 };
assign arb0_2 = inst[8:4];
assign arb0_0 = { inst[9], inst[3:0] };
assign arb00 = arbsel({
	x_muls | x_mulother | x_cbi | x_sbi | x_sbic | x_sbis | x_io,
	x_movw | x_muls | x_mulother | x_comneg | x_bld | x_bst | x_sbrc | x_sbrs,
	x_movw | x_mulother | x_io | i_lss
}, {
	arb0_7,	
	arb0_6,	
	arb0_5,	
	arb0_4,	
	arb0_3,	
	arb0_2, 
	inst[15:0], 
	arb0_0	
});
wire indirect_p = x_pop | x_ret | i_ret13;
wire indirect_m = x_lsmx | x_lsmy | x_lsmz;
wire indirect_d = x_lsyd | x_lszd;
wire indirect_sp = x_pushcall | indirect_p;
wire [15:0] indirect_ofs = {{ 11 { inst[13] }}, inst[11:10], inst[2:0] };
wire [15:0] ptr, ptradd;
LUT3 LUT3_ptradd0(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[0]), .O(ptradd[0]));
defparam LUT3_ptradd0.INIT = 'hf8;
LUT3 LUT3_ptradd1(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[1]), .O(ptradd[1]));
defparam LUT3_ptradd1.INIT = 'hf8;
LUT3 LUT3_ptradd2(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[2]), .O(ptradd[2]));
defparam LUT3_ptradd2.INIT = 'hf8;
LUT3 LUT3_ptradd3(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[3]), .O(ptradd[3]));
defparam LUT3_ptradd3.INIT = 'hf8;
LUT3 LUT3_ptradd4(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[4]), .O(ptradd[4]));
defparam LUT3_ptradd4.INIT = 'hf8;
LUT3 LUT3_ptradd5(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[5]), .O(ptradd[5]));
defparam LUT3_ptradd5.INIT = 'hf8;
LUT3 LUT3_ptradd6(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[6]), .O(ptradd[6]));
defparam LUT3_ptradd6.INIT = 'hf8;
LUT3 LUT3_ptradd7(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[7]), .O(ptradd[7]));
defparam LUT3_ptradd7.INIT = 'hf8;
LUT3 LUT3_ptradd8(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[8]), .O(ptradd[8]));
defparam LUT3_ptradd8.INIT = 'hf8;
LUT3 LUT3_ptradd9(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[9]), .O(ptradd[9]));
defparam LUT3_ptradd9.INIT = 'hf8;
LUT3 LUT3_ptradd10(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[10]), .O(ptradd[10]));
defparam LUT3_ptradd10.INIT = 'hf8;
LUT3 LUT3_ptradd11(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[11]), .O(ptradd[11]));
defparam LUT3_ptradd11.INIT = 'hf8;
LUT3 LUT3_ptradd12(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[12]), .O(ptradd[12]));
defparam LUT3_ptradd12.INIT = 'hf8;
LUT3 LUT3_ptradd13(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[13]), .O(ptradd[13]));
defparam LUT3_ptradd13.INIT = 'hf8;
LUT3 LUT3_ptradd14(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[14]), .O(ptradd[14]));
defparam LUT3_ptradd14.INIT = 'hf8;
LUT3 LUT3_ptradd15(.I2(indirect_m), .I1(indirect_d), .I0(indirect_ofs[15]), .O(ptradd[15]));
defparam LUT3_ptradd15.INIT = 'hf8;
wire indirect_g = x_lsx | x_lsxp | x_lsyp | x_lszp | indirect_m | indirect_d | indirect_sp;
wire arb0_g = indirect_g;
wire [15:0] arb0_t, arb0_a, arb0;
wire [15:0] arb0_c;
assign arb0_c[0] = indirect_p;
MULT_AND mult_and_arb00(.I1(arb0_g), .I0(ptr[0]), .LO(arb0_a[0]));
MUXCY muxcy_arb00(.S(arb0_t[0]), .DI(arb0_a[0]), .CI(arb0_c[0]), .O(arb0_c[0 + 1]));
XORCY xorcy_arb00(.LI(arb0_t[0]), .CI(arb0_c[0]), .O(arb0[0]));
MULT_AND mult_and_arb01(.I1(arb0_g), .I0(ptr[1]), .LO(arb0_a[1]));
MUXCY muxcy_arb01(.S(arb0_t[1]), .DI(arb0_a[1]), .CI(arb0_c[1]), .O(arb0_c[1 + 1]));
XORCY xorcy_arb01(.LI(arb0_t[1]), .CI(arb0_c[1]), .O(arb0[1]));
MULT_AND mult_and_arb02(.I1(arb0_g), .I0(ptr[2]), .LO(arb0_a[2]));
MUXCY muxcy_arb02(.S(arb0_t[2]), .DI(arb0_a[2]), .CI(arb0_c[2]), .O(arb0_c[2 + 1]));
XORCY xorcy_arb02(.LI(arb0_t[2]), .CI(arb0_c[2]), .O(arb0[2]));
MULT_AND mult_and_arb03(.I1(arb0_g), .I0(ptr[3]), .LO(arb0_a[3]));
MUXCY muxcy_arb03(.S(arb0_t[3]), .DI(arb0_a[3]), .CI(arb0_c[3]), .O(arb0_c[3 + 1]));
XORCY xorcy_arb03(.LI(arb0_t[3]), .CI(arb0_c[3]), .O(arb0[3]));
MULT_AND mult_and_arb04(.I1(arb0_g), .I0(ptr[4]), .LO(arb0_a[4]));
MUXCY muxcy_arb04(.S(arb0_t[4]), .DI(arb0_a[4]), .CI(arb0_c[4]), .O(arb0_c[4 + 1]));
XORCY xorcy_arb04(.LI(arb0_t[4]), .CI(arb0_c[4]), .O(arb0[4]));
MULT_AND mult_and_arb05(.I1(arb0_g), .I0(ptr[5]), .LO(arb0_a[5]));
MUXCY muxcy_arb05(.S(arb0_t[5]), .DI(arb0_a[5]), .CI(arb0_c[5]), .O(arb0_c[5 + 1]));
XORCY xorcy_arb05(.LI(arb0_t[5]), .CI(arb0_c[5]), .O(arb0[5]));
MULT_AND mult_and_arb06(.I1(arb0_g), .I0(ptr[6]), .LO(arb0_a[6]));
MUXCY muxcy_arb06(.S(arb0_t[6]), .DI(arb0_a[6]), .CI(arb0_c[6]), .O(arb0_c[6 + 1]));
XORCY xorcy_arb06(.LI(arb0_t[6]), .CI(arb0_c[6]), .O(arb0[6]));
MULT_AND mult_and_arb07(.I1(arb0_g), .I0(ptr[7]), .LO(arb0_a[7]));
MUXCY muxcy_arb07(.S(arb0_t[7]), .DI(arb0_a[7]), .CI(arb0_c[7]), .O(arb0_c[7 + 1]));
XORCY xorcy_arb07(.LI(arb0_t[7]), .CI(arb0_c[7]), .O(arb0[7]));
MULT_AND mult_and_arb08(.I1(arb0_g), .I0(ptr[8]), .LO(arb0_a[8]));
MUXCY muxcy_arb08(.S(arb0_t[8]), .DI(arb0_a[8]), .CI(arb0_c[8]), .O(arb0_c[8 + 1]));
XORCY xorcy_arb08(.LI(arb0_t[8]), .CI(arb0_c[8]), .O(arb0[8]));
MULT_AND mult_and_arb09(.I1(arb0_g), .I0(ptr[9]), .LO(arb0_a[9]));
MUXCY muxcy_arb09(.S(arb0_t[9]), .DI(arb0_a[9]), .CI(arb0_c[9]), .O(arb0_c[9 + 1]));
XORCY xorcy_arb09(.LI(arb0_t[9]), .CI(arb0_c[9]), .O(arb0[9]));
MULT_AND mult_and_arb010(.I1(arb0_g), .I0(ptr[10]), .LO(arb0_a[10]));
MUXCY muxcy_arb010(.S(arb0_t[10]), .DI(arb0_a[10]), .CI(arb0_c[10]), .O(arb0_c[10 + 1]));
XORCY xorcy_arb010(.LI(arb0_t[10]), .CI(arb0_c[10]), .O(arb0[10]));
MULT_AND mult_and_arb011(.I1(arb0_g), .I0(ptr[11]), .LO(arb0_a[11]));
MUXCY muxcy_arb011(.S(arb0_t[11]), .DI(arb0_a[11]), .CI(arb0_c[11]), .O(arb0_c[11 + 1]));
XORCY xorcy_arb011(.LI(arb0_t[11]), .CI(arb0_c[11]), .O(arb0[11]));
MULT_AND mult_and_arb012(.I1(arb0_g), .I0(ptr[12]), .LO(arb0_a[12]));
MUXCY muxcy_arb012(.S(arb0_t[12]), .DI(arb0_a[12]), .CI(arb0_c[12]), .O(arb0_c[12 + 1]));
XORCY xorcy_arb012(.LI(arb0_t[12]), .CI(arb0_c[12]), .O(arb0[12]));
MULT_AND mult_and_arb013(.I1(arb0_g), .I0(ptr[13]), .LO(arb0_a[13]));
MUXCY muxcy_arb013(.S(arb0_t[13]), .DI(arb0_a[13]), .CI(arb0_c[13]), .O(arb0_c[13 + 1]));
XORCY xorcy_arb013(.LI(arb0_t[13]), .CI(arb0_c[13]), .O(arb0[13]));
MULT_AND mult_and_arb014(.I1(arb0_g), .I0(ptr[14]), .LO(arb0_a[14]));
MUXCY muxcy_arb014(.S(arb0_t[14]), .DI(arb0_a[14]), .CI(arb0_c[14]), .O(arb0_c[14 + 1]));
XORCY xorcy_arb014(.LI(arb0_t[14]), .CI(arb0_c[14]), .O(arb0[14]));
MULT_AND mult_and_arb015(.I1(arb0_g), .I0(ptr[15]), .LO(arb0_a[15]));
MUXCY muxcy_arb015(.S(arb0_t[15]), .DI(arb0_a[15]), .CI(arb0_c[15]), .O());
XORCY xorcy_arb015(.LI(arb0_t[15]), .CI(arb0_c[15]), .O(arb0[15]));
LUT4 LUT4_arb0(.I3(indirect_g), .I2(arb00[0]), .I1(ptradd[0]), .I0(ptr[0]), .O(arb0_t[0]));
defparam LUT4_arb0.INIT = 'h66f0;
LUT4 LUT4_arb1(.I3(indirect_g), .I2(arb00[1]), .I1(ptradd[1]), .I0(ptr[1]), .O(arb0_t[1]));
defparam LUT4_arb1.INIT = 'h66f0;
LUT4 LUT4_arb2(.I3(indirect_g), .I2(arb00[2]), .I1(ptradd[2]), .I0(ptr[2]), .O(arb0_t[2]));
defparam LUT4_arb2.INIT = 'h66f0;
LUT4 LUT4_arb3(.I3(indirect_g), .I2(arb00[3]), .I1(ptradd[3]), .I0(ptr[3]), .O(arb0_t[3]));
defparam LUT4_arb3.INIT = 'h66f0;
LUT4 LUT4_arb4(.I3(indirect_g), .I2(arb00[4]), .I1(ptradd[4]), .I0(ptr[4]), .O(arb0_t[4]));
defparam LUT4_arb4.INIT = 'h66f0;
LUT4 LUT4_arb5(.I3(indirect_g), .I2(arb00[5]), .I1(ptradd[5]), .I0(ptr[5]), .O(arb0_t[5]));
defparam LUT4_arb5.INIT = 'h66f0;
LUT4 LUT4_arb6(.I3(indirect_g), .I2(arb00[6]), .I1(ptradd[6]), .I0(ptr[6]), .O(arb0_t[6]));
defparam LUT4_arb6.INIT = 'h66f0;
LUT4 LUT4_arb7(.I3(indirect_g), .I2(arb00[7]), .I1(ptradd[7]), .I0(ptr[7]), .O(arb0_t[7]));
defparam LUT4_arb7.INIT = 'h66f0;
LUT4 LUT4_arb8(.I3(indirect_g), .I2(arb00[8]), .I1(ptradd[8]), .I0(ptr[8]), .O(arb0_t[8]));
defparam LUT4_arb8.INIT = 'h66f0;
LUT4 LUT4_arb9(.I3(indirect_g), .I2(arb00[9]), .I1(ptradd[9]), .I0(ptr[9]), .O(arb0_t[9]));
defparam LUT4_arb9.INIT = 'h66f0;
LUT4 LUT4_arb10(.I3(indirect_g), .I2(arb00[10]), .I1(ptradd[10]), .I0(ptr[10]), .O(arb0_t[10]));
defparam LUT4_arb10.INIT = 'h66f0;
LUT4 LUT4_arb11(.I3(indirect_g), .I2(arb00[11]), .I1(ptradd[11]), .I0(ptr[11]), .O(arb0_t[11]));
defparam LUT4_arb11.INIT = 'h66f0;
LUT4 LUT4_arb12(.I3(indirect_g), .I2(arb00[12]), .I1(ptradd[12]), .I0(ptr[12]), .O(arb0_t[12]));
defparam LUT4_arb12.INIT = 'h66f0;
LUT4 LUT4_arb13(.I3(indirect_g), .I2(arb00[13]), .I1(ptradd[13]), .I0(ptr[13]), .O(arb0_t[13]));
defparam LUT4_arb13.INIT = 'h66f0;
LUT4 LUT4_arb14(.I3(indirect_g), .I2(arb00[14]), .I1(ptradd[14]), .I0(ptr[14]), .O(arb0_t[14]));
defparam LUT4_arb14.INIT = 'h66f0;
LUT4 LUT4_arb15(.I3(indirect_g), .I2(arb00[15]), .I1(ptradd[15]), .I0(ptr[15]), .O(arb0_t[15]));
defparam LUT4_arb15.INIT = 'h66f0;
wire [4:0] ara1, arb1;
wire sel_r0, sel_r1, sel_r2, sel_r3;
FDE FDE_ara0(.C(clk), .CE(valid), .D(ara0[0]), .Q(ara1[0]));
FDE FDE_ara1(.C(clk), .CE(valid), .D(ara0[1]), .Q(ara1[1]));
FDE FDE_ara2(.C(clk), .CE(valid), .D(ara0[2]), .Q(ara1[2]));
FDE FDE_ara3(.C(clk), .CE(valid), .D(ara0[3]), .Q(ara1[3]));
FDE FDE_ara4(.C(clk), .CE(valid), .D(ara0[4]), .Q(ara1[4]));
FDE FDE_arb0(.C(clk), .CE(valid), .D(arb0[0]), .Q(arb1[0]));
FDE FDE_arb1(.C(clk), .CE(valid), .D(arb0[1]), .Q(arb1[1]));
FDE FDE_arb2(.C(clk), .CE(valid), .D(arb0[2]), .Q(arb1[2]));
FDE FDE_arb3(.C(clk), .CE(valid), .D(arb0[3]), .Q(arb1[3]));
FDE FDE_arb4(.C(clk), .CE(valid), .D(arb0[4]), .Q(arb1[4]));
FDE rr0(.C(clk), .CE(valid), .D(&ara0[4:3] & ara0[1]), .Q(sel_r0));
FDE rr1(.C(clk), .CE(valid), .D(&ara0[4:2]), .Q(sel_r1));
FDE rr2(.C(clk), .CE(valid), .D(&arb0[4:3] & arb0[1]), .Q(sel_r2));
FDE rr3(.C(clk), .CE(valid), .D(&arb0[4:2]), .Q(sel_r3));
// synthesis attribute ram_style of rl is distributed;
// synthesis attribute ram_style of rh is distributed;
reg [7:0] rl[0:15], rh[0:15];
wire [15:0] x0, y0, z0, r00, r01, r10, r11, roa, rob;
wire [15:0] ra = { rh[ara1[4:1]], rl[ara1[4:1]] };
wire [15:0] rb = { rh[arb1[4:1]], rl[arb1[4:1]] };
LUT3 LUT3_r000(.I2(sel_r0), .I1(x0[0]), .I0(ra[0]), .O(r00[0]));
defparam LUT3_r000.INIT = 'hca;
LUT3 LUT3_r001(.I2(sel_r0), .I1(x0[1]), .I0(ra[1]), .O(r00[1]));
defparam LUT3_r001.INIT = 'hca;
LUT3 LUT3_r002(.I2(sel_r0), .I1(x0[2]), .I0(ra[2]), .O(r00[2]));
defparam LUT3_r002.INIT = 'hca;
LUT3 LUT3_r003(.I2(sel_r0), .I1(x0[3]), .I0(ra[3]), .O(r00[3]));
defparam LUT3_r003.INIT = 'hca;
LUT3 LUT3_r004(.I2(sel_r0), .I1(x0[4]), .I0(ra[4]), .O(r00[4]));
defparam LUT3_r004.INIT = 'hca;
LUT3 LUT3_r005(.I2(sel_r0), .I1(x0[5]), .I0(ra[5]), .O(r00[5]));
defparam LUT3_r005.INIT = 'hca;
LUT3 LUT3_r006(.I2(sel_r0), .I1(x0[6]), .I0(ra[6]), .O(r00[6]));
defparam LUT3_r006.INIT = 'hca;
LUT3 LUT3_r007(.I2(sel_r0), .I1(x0[7]), .I0(ra[7]), .O(r00[7]));
defparam LUT3_r007.INIT = 'hca;
LUT3 LUT3_r008(.I2(sel_r0), .I1(x0[8]), .I0(ra[8]), .O(r00[8]));
defparam LUT3_r008.INIT = 'hca;
LUT3 LUT3_r009(.I2(sel_r0), .I1(x0[9]), .I0(ra[9]), .O(r00[9]));
defparam LUT3_r009.INIT = 'hca;
LUT3 LUT3_r0010(.I2(sel_r0), .I1(x0[10]), .I0(ra[10]), .O(r00[10]));
defparam LUT3_r0010.INIT = 'hca;
LUT3 LUT3_r0011(.I2(sel_r0), .I1(x0[11]), .I0(ra[11]), .O(r00[11]));
defparam LUT3_r0011.INIT = 'hca;
LUT3 LUT3_r0012(.I2(sel_r0), .I1(x0[12]), .I0(ra[12]), .O(r00[12]));
defparam LUT3_r0012.INIT = 'hca;
LUT3 LUT3_r0013(.I2(sel_r0), .I1(x0[13]), .I0(ra[13]), .O(r00[13]));
defparam LUT3_r0013.INIT = 'hca;
LUT3 LUT3_r0014(.I2(sel_r0), .I1(x0[14]), .I0(ra[14]), .O(r00[14]));
defparam LUT3_r0014.INIT = 'hca;
LUT3 LUT3_r0015(.I2(sel_r0), .I1(x0[15]), .I0(ra[15]), .O(r00[15]));
defparam LUT3_r0015.INIT = 'hca;
LUT3 LUT3_r010(.I2(sel_r0), .I1(z0[0]), .I0(y0[0]), .O(r01[0]));
defparam LUT3_r010.INIT = 'hca;
LUT3 LUT3_r011(.I2(sel_r0), .I1(z0[1]), .I0(y0[1]), .O(r01[1]));
defparam LUT3_r011.INIT = 'hca;
LUT3 LUT3_r012(.I2(sel_r0), .I1(z0[2]), .I0(y0[2]), .O(r01[2]));
defparam LUT3_r012.INIT = 'hca;
LUT3 LUT3_r013(.I2(sel_r0), .I1(z0[3]), .I0(y0[3]), .O(r01[3]));
defparam LUT3_r013.INIT = 'hca;
LUT3 LUT3_r014(.I2(sel_r0), .I1(z0[4]), .I0(y0[4]), .O(r01[4]));
defparam LUT3_r014.INIT = 'hca;
LUT3 LUT3_r015(.I2(sel_r0), .I1(z0[5]), .I0(y0[5]), .O(r01[5]));
defparam LUT3_r015.INIT = 'hca;
LUT3 LUT3_r016(.I2(sel_r0), .I1(z0[6]), .I0(y0[6]), .O(r01[6]));
defparam LUT3_r016.INIT = 'hca;
LUT3 LUT3_r017(.I2(sel_r0), .I1(z0[7]), .I0(y0[7]), .O(r01[7]));
defparam LUT3_r017.INIT = 'hca;
LUT3 LUT3_r018(.I2(sel_r0), .I1(z0[8]), .I0(y0[8]), .O(r01[8]));
defparam LUT3_r018.INIT = 'hca;
LUT3 LUT3_r019(.I2(sel_r0), .I1(z0[9]), .I0(y0[9]), .O(r01[9]));
defparam LUT3_r019.INIT = 'hca;
LUT3 LUT3_r0110(.I2(sel_r0), .I1(z0[10]), .I0(y0[10]), .O(r01[10]));
defparam LUT3_r0110.INIT = 'hca;
LUT3 LUT3_r0111(.I2(sel_r0), .I1(z0[11]), .I0(y0[11]), .O(r01[11]));
defparam LUT3_r0111.INIT = 'hca;
LUT3 LUT3_r0112(.I2(sel_r0), .I1(z0[12]), .I0(y0[12]), .O(r01[12]));
defparam LUT3_r0112.INIT = 'hca;
LUT3 LUT3_r0113(.I2(sel_r0), .I1(z0[13]), .I0(y0[13]), .O(r01[13]));
defparam LUT3_r0113.INIT = 'hca;
LUT3 LUT3_r0114(.I2(sel_r0), .I1(z0[14]), .I0(y0[14]), .O(r01[14]));
defparam LUT3_r0114.INIT = 'hca;
LUT3 LUT3_r0115(.I2(sel_r0), .I1(z0[15]), .I0(y0[15]), .O(r01[15]));
defparam LUT3_r0115.INIT = 'hca;
MUXF5 MUXF5_r00(.S(sel_r1), .I1(r01[0]), .I0(r00[0]), .O(roa[0]));
MUXF5 MUXF5_r01(.S(sel_r1), .I1(r01[1]), .I0(r00[1]), .O(roa[1]));
MUXF5 MUXF5_r02(.S(sel_r1), .I1(r01[2]), .I0(r00[2]), .O(roa[2]));
MUXF5 MUXF5_r03(.S(sel_r1), .I1(r01[3]), .I0(r00[3]), .O(roa[3]));
MUXF5 MUXF5_r04(.S(sel_r1), .I1(r01[4]), .I0(r00[4]), .O(roa[4]));
MUXF5 MUXF5_r05(.S(sel_r1), .I1(r01[5]), .I0(r00[5]), .O(roa[5]));
MUXF5 MUXF5_r06(.S(sel_r1), .I1(r01[6]), .I0(r00[6]), .O(roa[6]));
MUXF5 MUXF5_r07(.S(sel_r1), .I1(r01[7]), .I0(r00[7]), .O(roa[7]));
MUXF5 MUXF5_r08(.S(sel_r1), .I1(r01[8]), .I0(r00[8]), .O(roa[8]));
MUXF5 MUXF5_r09(.S(sel_r1), .I1(r01[9]), .I0(r00[9]), .O(roa[9]));
MUXF5 MUXF5_r010(.S(sel_r1), .I1(r01[10]), .I0(r00[10]), .O(roa[10]));
MUXF5 MUXF5_r011(.S(sel_r1), .I1(r01[11]), .I0(r00[11]), .O(roa[11]));
MUXF5 MUXF5_r012(.S(sel_r1), .I1(r01[12]), .I0(r00[12]), .O(roa[12]));
MUXF5 MUXF5_r013(.S(sel_r1), .I1(r01[13]), .I0(r00[13]), .O(roa[13]));
MUXF5 MUXF5_r014(.S(sel_r1), .I1(r01[14]), .I0(r00[14]), .O(roa[14]));
MUXF5 MUXF5_r015(.S(sel_r1), .I1(r01[15]), .I0(r00[15]), .O(roa[15]));
LUT3 LUT3_r100(.I2(sel_r2), .I1(x0[0]), .I0(rb[0]), .O(r10[0]));
defparam LUT3_r100.INIT = 'hca;
LUT3 LUT3_r101(.I2(sel_r2), .I1(x0[1]), .I0(rb[1]), .O(r10[1]));
defparam LUT3_r101.INIT = 'hca;
LUT3 LUT3_r102(.I2(sel_r2), .I1(x0[2]), .I0(rb[2]), .O(r10[2]));
defparam LUT3_r102.INIT = 'hca;
LUT3 LUT3_r103(.I2(sel_r2), .I1(x0[3]), .I0(rb[3]), .O(r10[3]));
defparam LUT3_r103.INIT = 'hca;
LUT3 LUT3_r104(.I2(sel_r2), .I1(x0[4]), .I0(rb[4]), .O(r10[4]));
defparam LUT3_r104.INIT = 'hca;
LUT3 LUT3_r105(.I2(sel_r2), .I1(x0[5]), .I0(rb[5]), .O(r10[5]));
defparam LUT3_r105.INIT = 'hca;
LUT3 LUT3_r106(.I2(sel_r2), .I1(x0[6]), .I0(rb[6]), .O(r10[6]));
defparam LUT3_r106.INIT = 'hca;
LUT3 LUT3_r107(.I2(sel_r2), .I1(x0[7]), .I0(rb[7]), .O(r10[7]));
defparam LUT3_r107.INIT = 'hca;
LUT3 LUT3_r108(.I2(sel_r2), .I1(x0[8]), .I0(rb[8]), .O(r10[8]));
defparam LUT3_r108.INIT = 'hca;
LUT3 LUT3_r109(.I2(sel_r2), .I1(x0[9]), .I0(rb[9]), .O(r10[9]));
defparam LUT3_r109.INIT = 'hca;
LUT3 LUT3_r1010(.I2(sel_r2), .I1(x0[10]), .I0(rb[10]), .O(r10[10]));
defparam LUT3_r1010.INIT = 'hca;
LUT3 LUT3_r1011(.I2(sel_r2), .I1(x0[11]), .I0(rb[11]), .O(r10[11]));
defparam LUT3_r1011.INIT = 'hca;
LUT3 LUT3_r1012(.I2(sel_r2), .I1(x0[12]), .I0(rb[12]), .O(r10[12]));
defparam LUT3_r1012.INIT = 'hca;
LUT3 LUT3_r1013(.I2(sel_r2), .I1(x0[13]), .I0(rb[13]), .O(r10[13]));
defparam LUT3_r1013.INIT = 'hca;
LUT3 LUT3_r1014(.I2(sel_r2), .I1(x0[14]), .I0(rb[14]), .O(r10[14]));
defparam LUT3_r1014.INIT = 'hca;
LUT3 LUT3_r1015(.I2(sel_r2), .I1(x0[15]), .I0(rb[15]), .O(r10[15]));
defparam LUT3_r1015.INIT = 'hca;
LUT3 LUT3_r110(.I2(sel_r2), .I1(z0[0]), .I0(y0[0]), .O(r11[0]));
defparam LUT3_r110.INIT = 'hca;
LUT3 LUT3_r111(.I2(sel_r2), .I1(z0[1]), .I0(y0[1]), .O(r11[1]));
defparam LUT3_r111.INIT = 'hca;
LUT3 LUT3_r112(.I2(sel_r2), .I1(z0[2]), .I0(y0[2]), .O(r11[2]));
defparam LUT3_r112.INIT = 'hca;
LUT3 LUT3_r113(.I2(sel_r2), .I1(z0[3]), .I0(y0[3]), .O(r11[3]));
defparam LUT3_r113.INIT = 'hca;
LUT3 LUT3_r114(.I2(sel_r2), .I1(z0[4]), .I0(y0[4]), .O(r11[4]));
defparam LUT3_r114.INIT = 'hca;
LUT3 LUT3_r115(.I2(sel_r2), .I1(z0[5]), .I0(y0[5]), .O(r11[5]));
defparam LUT3_r115.INIT = 'hca;
LUT3 LUT3_r116(.I2(sel_r2), .I1(z0[6]), .I0(y0[6]), .O(r11[6]));
defparam LUT3_r116.INIT = 'hca;
LUT3 LUT3_r117(.I2(sel_r2), .I1(z0[7]), .I0(y0[7]), .O(r11[7]));
defparam LUT3_r117.INIT = 'hca;
LUT3 LUT3_r118(.I2(sel_r2), .I1(z0[8]), .I0(y0[8]), .O(r11[8]));
defparam LUT3_r118.INIT = 'hca;
LUT3 LUT3_r119(.I2(sel_r2), .I1(z0[9]), .I0(y0[9]), .O(r11[9]));
defparam LUT3_r119.INIT = 'hca;
LUT3 LUT3_r1110(.I2(sel_r2), .I1(z0[10]), .I0(y0[10]), .O(r11[10]));
defparam LUT3_r1110.INIT = 'hca;
LUT3 LUT3_r1111(.I2(sel_r2), .I1(z0[11]), .I0(y0[11]), .O(r11[11]));
defparam LUT3_r1111.INIT = 'hca;
LUT3 LUT3_r1112(.I2(sel_r2), .I1(z0[12]), .I0(y0[12]), .O(r11[12]));
defparam LUT3_r1112.INIT = 'hca;
LUT3 LUT3_r1113(.I2(sel_r2), .I1(z0[13]), .I0(y0[13]), .O(r11[13]));
defparam LUT3_r1113.INIT = 'hca;
LUT3 LUT3_r1114(.I2(sel_r2), .I1(z0[14]), .I0(y0[14]), .O(r11[14]));
defparam LUT3_r1114.INIT = 'hca;
LUT3 LUT3_r1115(.I2(sel_r2), .I1(z0[15]), .I0(y0[15]), .O(r11[15]));
defparam LUT3_r1115.INIT = 'hca;
MUXF5 MUXF5_r10(.S(sel_r3), .I1(r11[0]), .I0(r10[0]), .O(rob[0]));
MUXF5 MUXF5_r11(.S(sel_r3), .I1(r11[1]), .I0(r10[1]), .O(rob[1]));
MUXF5 MUXF5_r12(.S(sel_r3), .I1(r11[2]), .I0(r10[2]), .O(rob[2]));
MUXF5 MUXF5_r13(.S(sel_r3), .I1(r11[3]), .I0(r10[3]), .O(rob[3]));
MUXF5 MUXF5_r14(.S(sel_r3), .I1(r11[4]), .I0(r10[4]), .O(rob[4]));
MUXF5 MUXF5_r15(.S(sel_r3), .I1(r11[5]), .I0(r10[5]), .O(rob[5]));
MUXF5 MUXF5_r16(.S(sel_r3), .I1(r11[6]), .I0(r10[6]), .O(rob[6]));
MUXF5 MUXF5_r17(.S(sel_r3), .I1(r11[7]), .I0(r10[7]), .O(rob[7]));
MUXF5 MUXF5_r18(.S(sel_r3), .I1(r11[8]), .I0(r10[8]), .O(rob[8]));
MUXF5 MUXF5_r19(.S(sel_r3), .I1(r11[9]), .I0(r10[9]), .O(rob[9]));
MUXF5 MUXF5_r110(.S(sel_r3), .I1(r11[10]), .I0(r10[10]), .O(rob[10]));
MUXF5 MUXF5_r111(.S(sel_r3), .I1(r11[11]), .I0(r10[11]), .O(rob[11]));
MUXF5 MUXF5_r112(.S(sel_r3), .I1(r11[12]), .I0(r10[12]), .O(rob[12]));
MUXF5 MUXF5_r113(.S(sel_r3), .I1(r11[13]), .I0(r10[13]), .O(rob[13]));
MUXF5 MUXF5_r114(.S(sel_r3), .I1(r11[14]), .I0(r10[14]), .O(rob[14]));
MUXF5 MUXF5_r115(.S(sel_r3), .I1(r11[15]), .I0(r10[15]), .O(rob[15]));
wire addsub_sw, cyg, cyt, rmsb, logic, logic0, logic1, sel_alu0, sel_alu1;
wire sel_a_zero, sel_b_zero, sel_a_hot, sel_b0, sel_b1, sel_b2, sel_b3;
wire t_add = x_adc | x_add | x_adiw;
wire t_sub = x_sbc | x_sbci | x_sub | x_subi | x_sbiw;
wire t_subcp = t_sub | x_cp | x_cpc | x_cpi | x_cpse;
wire t_logic = x_and | x_andi | x_or | x_ori | x_eor | x_sbi | x_cbi;
wire t_sel_b_zero = x_incdec | x_store | x_push | x_out | i_adiwsbiw;
wire t_sel_b_const = x_andi | x_cpi | x_ldi | x_ori | x_subi | x_sbci;
wire arb0_spl = arb0 == 'h5d;
wire arb0_sph = arb0 == 'h5e;
wire arb0_sreg = arb0 == 'h5f;
wire t_isreg_b = ~|arb0[15:5];
FDE ex00(.C(clk), .CE(valid), .D(t_logic), .Q(logic));
FDE ex01(.C(clk), .CE(valid), .D(x_comneg | x_ldi | x_load | x_mov | x_pop | x_in), .Q(sel_a_zero));
FDE ex02(.C(clk), .CE(valid), .D(x_cbi | x_sbi | x_sbrc | x_sbrs | x_sbic | x_sbis | x_bld | x_bst | x_bclrbset), .Q(sel_a_hot));
FDE ex03(.C(clk), .CE(valid), .D(t_sel_b_zero), .Q(sel_b_zero));
FDE ex04(.C(clk), .CE(valid), .D(t_sel_b_zero | ~t_sel_b_const & ~x_adiwsbiw), .Q(sel_b0));
FDE ex05(.C(clk), .CE(valid), .D(arb0_spl | arb0_sreg | x_bclrbset), .Q(sel_b1));
FDE ex06(.C(clk), .CE(valid), .D(arb0_sph | arb0_sreg | x_bclrbset), .Q(sel_b2));
FDE ex07(.C(clk), .CE(valid), .D(~t_sel_b_zero & ~t_sel_b_const & ~x_adiwsbiw & ~t_isreg_b | x_bclrbset), .Q(sel_b3));
FDE ex08(.C(clk), .CE(valid), .D(t_subcp | x_comneg | x_dec), .Q(addsub_sw));
FDE ex09(.C(clk), .CE(valid), .D(x_adc | x_sbc | x_sbci | x_cpc | i_adiwsbiw), .Q(cyg));
FDE ex10(.C(clk), .CE(valid), .D(x_incdec | x_com), .Q(cyt));
FDE ex11(.C(clk), .CE(valid), .D(x_eor | x_cbi | x_bclr), .Q(logic0));
FDE ex12(.C(clk), .CE(valid), .D(x_eor | x_and | x_andi | x_sbrc | x_sbrs | x_sbic | x_sbis), .Q(logic1));
FDE ex13(.C(clk), .CE(valid), .D(t_logic | x_sbrc | x_sbrs | x_sbic | x_sbis | x_bld | x_bst | x_bclrbset), .Q(sel_alu0));
FDE ex14(.C(clk), .CE(valid), .D(x_swap | t_lpm | x_load | x_pop), .Q(sel_alu1));
wire [7:0] a, a0, a1, b, b0, b1, b00, b01, b10, b11;
reg [2:0] hot = 0;
always @(posedge clk) 
	if (valid) hot <= x_bclrbset ? inst[6:4] : inst[2:0];
LUT4 LUT4_a00(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[0 + 8]), .I0(roa[0]), .O(a0[0]));
defparam LUT4_a00.INIT = 'hca;
LUT4 LUT4_a01(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[1 + 8]), .I0(roa[1]), .O(a0[1]));
defparam LUT4_a01.INIT = 'hca;
LUT4 LUT4_a02(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[2 + 8]), .I0(roa[2]), .O(a0[2]));
defparam LUT4_a02.INIT = 'hca;
LUT4 LUT4_a03(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[3 + 8]), .I0(roa[3]), .O(a0[3]));
defparam LUT4_a03.INIT = 'hca;
LUT4 LUT4_a04(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[4 + 8]), .I0(roa[4]), .O(a0[4]));
defparam LUT4_a04.INIT = 'hca;
LUT4 LUT4_a05(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[5 + 8]), .I0(roa[5]), .O(a0[5]));
defparam LUT4_a05.INIT = 'hca;
LUT4 LUT4_a06(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[6 + 8]), .I0(roa[6]), .O(a0[6]));
defparam LUT4_a06.INIT = 'hca;
LUT4 LUT4_a07(.I3(sel_a_zero), .I2(ara1[0]), .I1(roa[7 + 8]), .I0(roa[7]), .O(a0[7]));
defparam LUT4_a07.INIT = 'hca;
LUT3 lut3_a10(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[0]));
defparam lut3_a10.INIT = 'h1;
LUT3 lut3_a11(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[1]));
defparam lut3_a11.INIT = 'h2;
LUT3 lut3_a12(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[2]));
defparam lut3_a12.INIT = 'h4;
LUT3 lut3_a13(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[3]));
defparam lut3_a13.INIT = 'h8;
LUT3 lut3_a14(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[4]));
defparam lut3_a14.INIT = 'h10;
LUT3 lut3_a15(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[5]));
defparam lut3_a15.INIT = 'h20;
LUT3 lut3_a16(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[6]));
defparam lut3_a16.INIT = 'h40;
LUT3 lut3_a17(.I2(hot[2]), .I1(hot[1]), .I0(hot[0]), .O(a1[7]));
defparam lut3_a17.INIT = 'h80;
MUXF5 MUXF5_a0(.S(sel_a_hot), .I1(a1[0]), .I0(a0[0]), .O(a[0]));
MUXF5 MUXF5_a1(.S(sel_a_hot), .I1(a1[1]), .I0(a0[1]), .O(a[1]));
MUXF5 MUXF5_a2(.S(sel_a_hot), .I1(a1[2]), .I0(a0[2]), .O(a[2]));
MUXF5 MUXF5_a3(.S(sel_a_hot), .I1(a1[3]), .I0(a0[3]), .O(a[3]));
MUXF5 MUXF5_a4(.S(sel_a_hot), .I1(a1[4]), .I0(a0[4]), .O(a[4]));
MUXF5 MUXF5_a5(.S(sel_a_hot), .I1(a1[5]), .I0(a0[5]), .O(a[5]));
MUXF5 MUXF5_a6(.S(sel_a_hot), .I1(a1[6]), .I0(a0[6]), .O(a[6]));
MUXF5 MUXF5_a7(.S(sel_a_hot), .I1(a1[7]), .I0(a0[7]), .O(a[7]));
assign b00[3:0] = ix[3:0];
LUT3 LUT3_b000(.I2(i_adiwsbiw), .I1(ix[0 + 6]), .I0(ix[0 + 8]), .O(b00[0 + 4]));
defparam LUT3_b000.INIT = 'hca;
LUT3 LUT3_b001(.I2(i_adiwsbiw), .I1(ix[1 + 6]), .I0(ix[1 + 8]), .O(b00[1 + 4]));
defparam LUT3_b001.INIT = 'hca;
LUT2 LUT2_b000(.I1(i_adiwsbiw), .I0(ix[0 + 10]), .O(b00[0 + 6]));
defparam LUT2_b000.INIT = 2;
LUT2 LUT2_b001(.I1(i_adiwsbiw), .I0(ix[1 + 10]), .O(b00[1 + 6]));
defparam LUT2_b001.INIT = 2;
LUT4 LUT4_b010(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[0 + 8]), .I0(rob[0]), .O(b01[0]));
defparam LUT4_b010.INIT = 'hca;
LUT4 LUT4_b011(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[1 + 8]), .I0(rob[1]), .O(b01[1]));
defparam LUT4_b011.INIT = 'hca;
LUT4 LUT4_b012(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[2 + 8]), .I0(rob[2]), .O(b01[2]));
defparam LUT4_b012.INIT = 'hca;
LUT4 LUT4_b013(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[3 + 8]), .I0(rob[3]), .O(b01[3]));
defparam LUT4_b013.INIT = 'hca;
LUT4 LUT4_b014(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[4 + 8]), .I0(rob[4]), .O(b01[4]));
defparam LUT4_b014.INIT = 'hca;
LUT4 LUT4_b015(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[5 + 8]), .I0(rob[5]), .O(b01[5]));
defparam LUT4_b015.INIT = 'hca;
LUT4 LUT4_b016(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[6 + 8]), .I0(rob[6]), .O(b01[6]));
defparam LUT4_b016.INIT = 'hca;
LUT4 LUT4_b017(.I3(sel_b_zero), .I2(arb1[0]), .I1(rob[7 + 8]), .I0(rob[7]), .O(b01[7]));
defparam LUT4_b017.INIT = 'hca;
MUXF5 MUXF5_b00(.S(sel_b0), .I1(b01[0]), .I0(b00[0]), .O(b0[0]));
MUXF5 MUXF5_b01(.S(sel_b0), .I1(b01[1]), .I0(b00[1]), .O(b0[1]));
MUXF5 MUXF5_b02(.S(sel_b0), .I1(b01[2]), .I0(b00[2]), .O(b0[2]));
MUXF5 MUXF5_b03(.S(sel_b0), .I1(b01[3]), .I0(b00[3]), .O(b0[3]));
MUXF5 MUXF5_b04(.S(sel_b0), .I1(b01[4]), .I0(b00[4]), .O(b0[4]));
MUXF5 MUXF5_b05(.S(sel_b0), .I1(b01[5]), .I0(b00[5]), .O(b0[5]));
MUXF5 MUXF5_b06(.S(sel_b0), .I1(b01[6]), .I0(b00[6]), .O(b0[6]));
MUXF5 MUXF5_b07(.S(sel_b0), .I1(b01[7]), .I0(b00[7]), .O(b0[7]));
wire [15:0] sp0;
LUT3 LUT3_b100(.I2(sel_b1), .I1(sp0[0]), .I0(data_in[0]), .O(b10[0]));
defparam LUT3_b100.INIT = 'hca;
LUT3 LUT3_b101(.I2(sel_b1), .I1(sp0[1]), .I0(data_in[1]), .O(b10[1]));
defparam LUT3_b101.INIT = 'hca;
LUT3 LUT3_b102(.I2(sel_b1), .I1(sp0[2]), .I0(data_in[2]), .O(b10[2]));
defparam LUT3_b102.INIT = 'hca;
LUT3 LUT3_b103(.I2(sel_b1), .I1(sp0[3]), .I0(data_in[3]), .O(b10[3]));
defparam LUT3_b103.INIT = 'hca;
LUT3 LUT3_b104(.I2(sel_b1), .I1(sp0[4]), .I0(data_in[4]), .O(b10[4]));
defparam LUT3_b104.INIT = 'hca;
LUT3 LUT3_b105(.I2(sel_b1), .I1(sp0[5]), .I0(data_in[5]), .O(b10[5]));
defparam LUT3_b105.INIT = 'hca;
LUT3 LUT3_b106(.I2(sel_b1), .I1(sp0[6]), .I0(data_in[6]), .O(b10[6]));
defparam LUT3_b106.INIT = 'hca;
LUT3 LUT3_b107(.I2(sel_b1), .I1(sp0[7]), .I0(data_in[7]), .O(b10[7]));
defparam LUT3_b107.INIT = 'hca;
wire [7:0] sp0h_e = sp0[15:8];
LUT3 LUT3_b110(.I2(sel_b1), .I1(sreg[0]), .I0(sp0h_e[0]), .O(b11[0]));
defparam LUT3_b110.INIT = 'hca;
LUT3 LUT3_b111(.I2(sel_b1), .I1(sreg[1]), .I0(sp0h_e[1]), .O(b11[1]));
defparam LUT3_b111.INIT = 'hca;
LUT3 LUT3_b112(.I2(sel_b1), .I1(sreg[2]), .I0(sp0h_e[2]), .O(b11[2]));
defparam LUT3_b112.INIT = 'hca;
LUT3 LUT3_b113(.I2(sel_b1), .I1(sreg[3]), .I0(sp0h_e[3]), .O(b11[3]));
defparam LUT3_b113.INIT = 'hca;
LUT3 LUT3_b114(.I2(sel_b1), .I1(sreg[4]), .I0(sp0h_e[4]), .O(b11[4]));
defparam LUT3_b114.INIT = 'hca;
LUT3 LUT3_b115(.I2(sel_b1), .I1(sreg[5]), .I0(sp0h_e[5]), .O(b11[5]));
defparam LUT3_b115.INIT = 'hca;
LUT3 LUT3_b116(.I2(sel_b1), .I1(sreg[6]), .I0(sp0h_e[6]), .O(b11[6]));
defparam LUT3_b116.INIT = 'hca;
LUT3 LUT3_b117(.I2(sel_b1), .I1(sreg[7]), .I0(sp0h_e[7]), .O(b11[7]));
defparam LUT3_b117.INIT = 'hca;
MUXF5 MUXF5_b10(.S(sel_b2), .I1(b11[0]), .I0(b10[0]), .O(b1[0]));
MUXF5 MUXF5_b11(.S(sel_b2), .I1(b11[1]), .I0(b10[1]), .O(b1[1]));
MUXF5 MUXF5_b12(.S(sel_b2), .I1(b11[2]), .I0(b10[2]), .O(b1[2]));
MUXF5 MUXF5_b13(.S(sel_b2), .I1(b11[3]), .I0(b10[3]), .O(b1[3]));
MUXF5 MUXF5_b14(.S(sel_b2), .I1(b11[4]), .I0(b10[4]), .O(b1[4]));
MUXF5 MUXF5_b15(.S(sel_b2), .I1(b11[5]), .I0(b10[5]), .O(b1[5]));
MUXF5 MUXF5_b16(.S(sel_b2), .I1(b11[6]), .I0(b10[6]), .O(b1[6]));
MUXF5 MUXF5_b17(.S(sel_b2), .I1(b11[7]), .I0(b10[7]), .O(b1[7]));
MUXF6 MUXF6_b0(.S(sel_b3), .I1(b1[0]), .I0(b0[0]), .O(b[0]));
MUXF6 MUXF6_b1(.S(sel_b3), .I1(b1[1]), .I0(b0[1]), .O(b[1]));
MUXF6 MUXF6_b2(.S(sel_b3), .I1(b1[2]), .I0(b0[2]), .O(b[2]));
MUXF6 MUXF6_b3(.S(sel_b3), .I1(b1[3]), .I0(b0[3]), .O(b[3]));
MUXF6 MUXF6_b4(.S(sel_b3), .I1(b1[4]), .I0(b0[4]), .O(b[4]));
MUXF6 MUXF6_b5(.S(sel_b3), .I1(b1[5]), .I0(b0[5]), .O(b[5]));
MUXF6 MUXF6_b6(.S(sel_b3), .I1(b1[6]), .I0(b0[6]), .O(b[6]));
MUXF6 MUXF6_b7(.S(sel_b3), .I1(b1[7]), .I0(b0[7]), .O(b[7]));
wire [7:0] logic_o, alu00, alu10, alu11, alu1, alu_y, alu_wb;
wire [7:0] arith_t, arith_a, arith;
wire [8:0] arith_c;
assign arith_c[0] = addsub_sw ^ (cyg & sreg[0] | cyt);
assign arith_a = a;
MUXCY muxcy_arith0(.S(arith_t[0]), .DI(arith_a[0]), .CI(arith_c[0]), .O(arith_c[0 + 1]));
XORCY xorcy_arith0(.LI(arith_t[0]), .CI(arith_c[0]), .O(arith[0]));
MUXCY muxcy_arith1(.S(arith_t[1]), .DI(arith_a[1]), .CI(arith_c[1]), .O(arith_c[1 + 1]));
XORCY xorcy_arith1(.LI(arith_t[1]), .CI(arith_c[1]), .O(arith[1]));
MUXCY muxcy_arith2(.S(arith_t[2]), .DI(arith_a[2]), .CI(arith_c[2]), .O(arith_c[2 + 1]));
XORCY xorcy_arith2(.LI(arith_t[2]), .CI(arith_c[2]), .O(arith[2]));
MUXCY muxcy_arith3(.S(arith_t[3]), .DI(arith_a[3]), .CI(arith_c[3]), .O(arith_c[3 + 1]));
XORCY xorcy_arith3(.LI(arith_t[3]), .CI(arith_c[3]), .O(arith[3]));
MUXCY muxcy_arith4(.S(arith_t[4]), .DI(arith_a[4]), .CI(arith_c[4]), .O(arith_c[4 + 1]));
XORCY xorcy_arith4(.LI(arith_t[4]), .CI(arith_c[4]), .O(arith[4]));
MUXCY muxcy_arith5(.S(arith_t[5]), .DI(arith_a[5]), .CI(arith_c[5]), .O(arith_c[5 + 1]));
XORCY xorcy_arith5(.LI(arith_t[5]), .CI(arith_c[5]), .O(arith[5]));
MUXCY muxcy_arith6(.S(arith_t[6]), .DI(arith_a[6]), .CI(arith_c[6]), .O(arith_c[6 + 1]));
XORCY xorcy_arith6(.LI(arith_t[6]), .CI(arith_c[6]), .O(arith[6]));
MUXCY muxcy_arith7(.S(arith_t[7]), .DI(arith_a[7]), .CI(arith_c[7]), .O(arith_c[7 + 1]));
XORCY xorcy_arith7(.LI(arith_t[7]), .CI(arith_c[7]), .O(arith[7]));
LUT3 LUT3_arith0(.I2(addsub_sw), .I1(b[0]), .I0(a0[0]), .O(arith_t[0]));
defparam LUT3_arith0.INIT = 'h96;
LUT3 LUT3_arith1(.I2(addsub_sw), .I1(b[1]), .I0(a0[1]), .O(arith_t[1]));
defparam LUT3_arith1.INIT = 'h96;
LUT3 LUT3_arith2(.I2(addsub_sw), .I1(b[2]), .I0(a0[2]), .O(arith_t[2]));
defparam LUT3_arith2.INIT = 'h96;
LUT3 LUT3_arith3(.I2(addsub_sw), .I1(b[3]), .I0(a0[3]), .O(arith_t[3]));
defparam LUT3_arith3.INIT = 'h96;
LUT3 LUT3_arith4(.I2(addsub_sw), .I1(b[4]), .I0(a0[4]), .O(arith_t[4]));
defparam LUT3_arith4.INIT = 'h96;
LUT3 LUT3_arith5(.I2(addsub_sw), .I1(b[5]), .I0(a0[5]), .O(arith_t[5]));
defparam LUT3_arith5.INIT = 'h96;
LUT3 LUT3_arith6(.I2(addsub_sw), .I1(b[6]), .I0(a0[6]), .O(arith_t[6]));
defparam LUT3_arith6.INIT = 'h96;
LUT3 LUT3_arith7(.I2(addsub_sw), .I1(b[7]), .I0(a0[7]), .O(arith_t[7]));
defparam LUT3_arith7.INIT = 'h96;
LUT4 lut4_rmsb(.I3(ix[1]), .I2(ix[0]), .I1(a0[7]), .I0(sreg[0]), .O(rmsb));
defparam lut4_rmsb.INIT = 'ha0c0;
wire [7:0] rsd = { rmsb, a0[7:1] }, swapd = { a0[3:0], a0[7:4] };
LUT3 LUT3_alu000(.I2(shift_right), .I1(rsd[0]), .I0(arith[0]), .O(alu00[0]));
defparam LUT3_alu000.INIT = 'hca;
LUT3 LUT3_alu001(.I2(shift_right), .I1(rsd[1]), .I0(arith[1]), .O(alu00[1]));
defparam LUT3_alu001.INIT = 'hca;
LUT3 LUT3_alu002(.I2(shift_right), .I1(rsd[2]), .I0(arith[2]), .O(alu00[2]));
defparam LUT3_alu002.INIT = 'hca;
LUT3 LUT3_alu003(.I2(shift_right), .I1(rsd[3]), .I0(arith[3]), .O(alu00[3]));
defparam LUT3_alu003.INIT = 'hca;
LUT3 LUT3_alu004(.I2(shift_right), .I1(rsd[4]), .I0(arith[4]), .O(alu00[4]));
defparam LUT3_alu004.INIT = 'hca;
LUT3 LUT3_alu005(.I2(shift_right), .I1(rsd[5]), .I0(arith[5]), .O(alu00[5]));
defparam LUT3_alu005.INIT = 'hca;
LUT3 LUT3_alu006(.I2(shift_right), .I1(rsd[6]), .I0(arith[6]), .O(alu00[6]));
defparam LUT3_alu006.INIT = 'hca;
LUT3 LUT3_alu007(.I2(shift_right), .I1(rsd[7]), .I0(arith[7]), .O(alu00[7]));
defparam LUT3_alu007.INIT = 'hca;
wire logic0t = logic0 | ix_bld & ~sreg[6];
LUT4 LUT4_logic0(.I3(logic1), .I2(logic0t), .I1(b[0]), .I0(a[0]), .O(logic_o[0]));
defparam LUT4_logic0.INIT = 'h684e;
LUT4 LUT4_logic1(.I3(logic1), .I2(logic0t), .I1(b[1]), .I0(a[1]), .O(logic_o[1]));
defparam LUT4_logic1.INIT = 'h684e;
LUT4 LUT4_logic2(.I3(logic1), .I2(logic0t), .I1(b[2]), .I0(a[2]), .O(logic_o[2]));
defparam LUT4_logic2.INIT = 'h684e;
LUT4 LUT4_logic3(.I3(logic1), .I2(logic0t), .I1(b[3]), .I0(a[3]), .O(logic_o[3]));
defparam LUT4_logic3.INIT = 'h684e;
LUT4 LUT4_logic4(.I3(logic1), .I2(logic0t), .I1(b[4]), .I0(a[4]), .O(logic_o[4]));
defparam LUT4_logic4.INIT = 'h684e;
LUT4 LUT4_logic5(.I3(logic1), .I2(logic0t), .I1(b[5]), .I0(a[5]), .O(logic_o[5]));
defparam LUT4_logic5.INIT = 'h684e;
LUT4 LUT4_logic6(.I3(logic1), .I2(logic0t), .I1(b[6]), .I0(a[6]), .O(logic_o[6]));
defparam LUT4_logic6.INIT = 'h684e;
LUT4 LUT4_logic7(.I3(logic1), .I2(logic0t), .I1(b[7]), .I0(a[7]), .O(logic_o[7]));
defparam LUT4_logic7.INIT = 'h684e;
MUXF5 MUXF5_alu00(.S(sel_alu0), .I1(logic_o[0]), .I0(alu00[0]), .O(alu_y[0]));
MUXF5 MUXF5_alu01(.S(sel_alu0), .I1(logic_o[1]), .I0(alu00[1]), .O(alu_y[1]));
MUXF5 MUXF5_alu02(.S(sel_alu0), .I1(logic_o[2]), .I0(alu00[2]), .O(alu_y[2]));
MUXF5 MUXF5_alu03(.S(sel_alu0), .I1(logic_o[3]), .I0(alu00[3]), .O(alu_y[3]));
MUXF5 MUXF5_alu04(.S(sel_alu0), .I1(logic_o[4]), .I0(alu00[4]), .O(alu_y[4]));
MUXF5 MUXF5_alu05(.S(sel_alu0), .I1(logic_o[5]), .I0(alu00[5]), .O(alu_y[5]));
MUXF5 MUXF5_alu06(.S(sel_alu0), .I1(logic_o[6]), .I0(alu00[6]), .O(alu_y[6]));
MUXF5 MUXF5_alu07(.S(sel_alu0), .I1(logic_o[7]), .I0(alu00[7]), .O(alu_y[7]));
LUT3 LUT3_alu100(.I2(ix_swap), .I1(swapd[0]), .I0(data_in_ram[0]), .O(alu10[0]));
defparam LUT3_alu100.INIT = 'hca;
LUT3 LUT3_alu101(.I2(ix_swap), .I1(swapd[1]), .I0(data_in_ram[1]), .O(alu10[1]));
defparam LUT3_alu101.INIT = 'hca;
LUT3 LUT3_alu102(.I2(ix_swap), .I1(swapd[2]), .I0(data_in_ram[2]), .O(alu10[2]));
defparam LUT3_alu102.INIT = 'hca;
LUT3 LUT3_alu103(.I2(ix_swap), .I1(swapd[3]), .I0(data_in_ram[3]), .O(alu10[3]));
defparam LUT3_alu103.INIT = 'hca;
LUT3 LUT3_alu104(.I2(ix_swap), .I1(swapd[4]), .I0(data_in_ram[4]), .O(alu10[4]));
defparam LUT3_alu104.INIT = 'hca;
LUT3 LUT3_alu105(.I2(ix_swap), .I1(swapd[5]), .I0(data_in_ram[5]), .O(alu10[5]));
defparam LUT3_alu105.INIT = 'hca;
LUT3 LUT3_alu106(.I2(ix_swap), .I1(swapd[6]), .I0(data_in_ram[6]), .O(alu10[6]));
defparam LUT3_alu106.INIT = 'hca;
LUT3 LUT3_alu107(.I2(ix_swap), .I1(swapd[7]), .I0(data_in_ram[7]), .O(alu10[7]));
defparam LUT3_alu107.INIT = 'hca;
LUT3 LUT3_alu110(.I2(z0[0]), .I1(inst[0 + 8]), .I0(inst[0]), .O(alu11[0]));
defparam LUT3_alu110.INIT = 'hca;
LUT3 LUT3_alu111(.I2(z0[0]), .I1(inst[1 + 8]), .I0(inst[1]), .O(alu11[1]));
defparam LUT3_alu111.INIT = 'hca;
LUT3 LUT3_alu112(.I2(z0[0]), .I1(inst[2 + 8]), .I0(inst[2]), .O(alu11[2]));
defparam LUT3_alu112.INIT = 'hca;
LUT3 LUT3_alu113(.I2(z0[0]), .I1(inst[3 + 8]), .I0(inst[3]), .O(alu11[3]));
defparam LUT3_alu113.INIT = 'hca;
LUT3 LUT3_alu114(.I2(z0[0]), .I1(inst[4 + 8]), .I0(inst[4]), .O(alu11[4]));
defparam LUT3_alu114.INIT = 'hca;
LUT3 LUT3_alu115(.I2(z0[0]), .I1(inst[5 + 8]), .I0(inst[5]), .O(alu11[5]));
defparam LUT3_alu115.INIT = 'hca;
LUT3 LUT3_alu116(.I2(z0[0]), .I1(inst[6 + 8]), .I0(inst[6]), .O(alu11[6]));
defparam LUT3_alu116.INIT = 'hca;
LUT3 LUT3_alu117(.I2(z0[0]), .I1(inst[7 + 8]), .I0(inst[7]), .O(alu11[7]));
defparam LUT3_alu117.INIT = 'hca;
MUXF5 MUXF5_alu10(.S(lpm), .I1(alu11[0]), .I0(alu10[0]), .O(alu1[0]));
MUXF5 MUXF5_alu11(.S(lpm), .I1(alu11[1]), .I0(alu10[1]), .O(alu1[1]));
MUXF5 MUXF5_alu12(.S(lpm), .I1(alu11[2]), .I0(alu10[2]), .O(alu1[2]));
MUXF5 MUXF5_alu13(.S(lpm), .I1(alu11[3]), .I0(alu10[3]), .O(alu1[3]));
MUXF5 MUXF5_alu14(.S(lpm), .I1(alu11[4]), .I0(alu10[4]), .O(alu1[4]));
MUXF5 MUXF5_alu15(.S(lpm), .I1(alu11[5]), .I0(alu10[5]), .O(alu1[5]));
MUXF5 MUXF5_alu16(.S(lpm), .I1(alu11[6]), .I0(alu10[6]), .O(alu1[6]));
MUXF5 MUXF5_alu17(.S(lpm), .I1(alu11[7]), .I0(alu10[7]), .O(alu1[7]));
MUXF6 MUXF6_alu0(.S(sel_alu1), .I1(alu1[0]), .I0(alu_y[0]), .O(alu_wb[0]));
MUXF6 MUXF6_alu1(.S(sel_alu1), .I1(alu1[1]), .I0(alu_y[1]), .O(alu_wb[1]));
MUXF6 MUXF6_alu2(.S(sel_alu1), .I1(alu1[2]), .I0(alu_y[2]), .O(alu_wb[2]));
MUXF6 MUXF6_alu3(.S(sel_alu1), .I1(alu1[3]), .I0(alu_y[3]), .O(alu_wb[3]));
MUXF6 MUXF6_alu4(.S(sel_alu1), .I1(alu1[4]), .I0(alu_y[4]), .O(alu_wb[4]));
MUXF6 MUXF6_alu5(.S(sel_alu1), .I1(alu1[5]), .I0(alu_y[5]), .O(alu_wb[5]));
MUXF6 MUXF6_alu6(.S(sel_alu1), .I1(alu1[6]), .I0(alu_y[6]), .O(alu_wb[6]));
MUXF6 MUXF6_alu7(.S(sel_alu1), .I1(alu1[7]), .I0(alu_y[7]), .O(alu_wb[7]));
assign alu_z = ~|alu_y;
`ifdef MEGA
wire mul0, mul1, mul2;
FDE ex15(.C(clk), .CE(valid), .D(x_muls | x_mulsu | x_fmuls | x_fmulsu), .Q(mul0));
FDE ex16(.C(clk), .CE(valid), .D(x_muls | x_fmuls), .Q(mul1));
FDE ex17(.C(clk), .CE(valid), .D(x_fmul | x_fmuls | x_fmulsu), .Q(mul2));
wire signed [8:0] mul_a, mul_b;
MUXF6 MUXF6_r00(.S(ara1[0]), .I1(roa[0 + 8]), .I0(roa[0]), .O(mul_a[0]));
MUXF6 MUXF6_r01(.S(ara1[0]), .I1(roa[1 + 8]), .I0(roa[1]), .O(mul_a[1]));
MUXF6 MUXF6_r02(.S(ara1[0]), .I1(roa[2 + 8]), .I0(roa[2]), .O(mul_a[2]));
MUXF6 MUXF6_r03(.S(ara1[0]), .I1(roa[3 + 8]), .I0(roa[3]), .O(mul_a[3]));
MUXF6 MUXF6_r04(.S(ara1[0]), .I1(roa[4 + 8]), .I0(roa[4]), .O(mul_a[4]));
MUXF6 MUXF6_r05(.S(ara1[0]), .I1(roa[5 + 8]), .I0(roa[5]), .O(mul_a[5]));
MUXF6 MUXF6_r06(.S(ara1[0]), .I1(roa[6 + 8]), .I0(roa[6]), .O(mul_a[6]));
MUXF6 MUXF6_r07(.S(ara1[0]), .I1(roa[7 + 8]), .I0(roa[7]), .O(mul_a[7]));
MUXF6 MUXF6_r10(.S(arb1[0]), .I1(rob[0 + 8]), .I0(rob[0]), .O(mul_b[0]));
MUXF6 MUXF6_r11(.S(arb1[0]), .I1(rob[1 + 8]), .I0(rob[1]), .O(mul_b[1]));
MUXF6 MUXF6_r12(.S(arb1[0]), .I1(rob[2 + 8]), .I0(rob[2]), .O(mul_b[2]));
MUXF6 MUXF6_r13(.S(arb1[0]), .I1(rob[3 + 8]), .I0(rob[3]), .O(mul_b[3]));
MUXF6 MUXF6_r14(.S(arb1[0]), .I1(rob[4 + 8]), .I0(rob[4]), .O(mul_b[4]));
MUXF6 MUXF6_r15(.S(arb1[0]), .I1(rob[5 + 8]), .I0(rob[5]), .O(mul_b[5]));
MUXF6 MUXF6_r16(.S(arb1[0]), .I1(rob[6 + 8]), .I0(rob[6]), .O(mul_b[6]));
MUXF6 MUXF6_r17(.S(arb1[0]), .I1(rob[7 + 8]), .I0(rob[7]), .O(mul_b[7]));
assign mul_a[8] = mul0 & mul_a[7];
assign mul_b[8] = mul1 & mul_b[7];
wire [17:0] mul_o = mul_a * mul_b;
wire mul_c = mul_o[15];
wire mul_z = ~|mul_o[14:0] & (~mul_o[15] | mul2);
`else
wire mul_c = 0, mul_z = 0;
`endif
wire t_g_c = t_add | t_subcp | x_comneg | t_shift_right | x_mulall;
wire t_g_z = t_g_c | t_logic | x_incdec;
wire g_c, g_z, g_nvs, g_h, g_t, g_i, d_v, concat_z, load_sreg;
FDRE f0(.C(clk), .R(reset_f), .CE(valid), .D(iacc2 | x_reti), .Q(g_i));
FDRE f1(.C(clk), .R(reset_f), .CE(valid), .D(x_bst), .Q(g_t));
FDRE f2(.C(clk), .R(reset_f), .CE(valid), .D(t_add | t_subcp | x_neg), .Q(g_h));
FDRE f3(.C(clk), .R(reset_f), .CE(valid), .D(t_g_z & ~x_mulall), .Q(g_nvs));
FDRE f4(.C(clk), .R(reset_f), .CE(valid), .D(t_g_z), .Q(g_z));
FDRE f5(.C(clk), .R(reset_f), .CE(valid), .D(t_g_c), .Q(g_c));
wire [1:0] sel_c;
FDE f6(.C(clk), .CE(valid), .D(i_adiwsbiw | x_sbc | x_sbci | x_cpc), .Q(concat_z));
FDE f7(.C(clk), .CE(valid), .D(x_neg | x_mulall), .Q(sel_c[0]));
FDE f8(.C(clk), .CE(valid), .D(t_shift_right | x_mulall), .Q(sel_c[1]));
wire [3:0] d_c_t = { mul_c, a[0], ~alu_z, addsub_sw ^ arith_c[8] };
wire sreg_d_c = d_c_t[sel_c] | ix_com;
LUT4 lut4_v(.I3(addsub_sw), .I2(arith[7]), .I1(b[7]), .I0(a0[7]), .O(d_v));
defparam lut4_v.INIT = 'h4218;
wire sreg_d_v = ~logic & (shift_right ? alu_y[7] ^ sreg_d_c : d_v);
FDRE fdre_sreg_i(.C(clk), .R(reset), .CE(valid & (load_sreg | g_i)),
	.D(load_sreg ? alu_y[7] : x_reti),
	.Q(sreg[7]));
FDRE fdre_sreg_t(.C(clk), .R(reset), .CE(valid & (load_sreg | g_t)),
	.D(load_sreg ? alu_y[6] : ~alu_z),
	.Q(sreg[6]));
FDRE fdre_sreg_h(.C(clk), .R(reset), .CE(valid & (load_sreg | g_h)),
	.D(load_sreg ? alu_y[5] : ix_neg ? arith[3] | a[3] : addsub_sw ^ arith_c[4]),
	.Q(sreg[5]));
FDRE fdre_sreg_s(.C(clk), .R(reset), .CE(valid & (load_sreg | g_nvs)),
	.D(load_sreg ? alu_y[4] : (sreg_d_v ^ alu_y[7])),
	.Q(sreg[4]));
FDRE fdre_sreg_v(.C(clk), .R(reset), .CE(valid & (load_sreg | g_nvs)),
	.D(load_sreg ? alu_y[3] : sreg_d_v),
	.Q(sreg[3]));
FDRE fdre_sreg_n(.C(clk), .R(reset), .CE(valid & (load_sreg | g_nvs)),
	.D(load_sreg ? alu_y[2] : alu_y[7]),
	.Q(sreg[2]));
FDRE fdre_sreg_z(.C(clk), .R(reset), .CE(valid & (load_sreg | g_z)),
	.D(load_sreg ? alu_y[1] : ix_mulall ? mul_z : alu_z & (~concat_z | sreg[1])),
	.Q(sreg[1]));
FDRE fdre_sreg_c(.C(clk), .R(reset), .CE(valid & (load_sreg | g_c)),
	.D(load_sreg ? alu_y[0] : sreg_d_c),
	.Q(sreg[0]));
wire wreg, load_spl, load_sph, l_ce, h_ce;
wire t_write = ~force_nop & (x_load | x_store | x_ldi | x_bld | t_add | 
	t_shift_right | x_pop | t_lpm | x_swap | t_sub | t_logic | x_mov | 
	x_movw | x_mul | x_muls | x_mulother | x_comneg | x_io | x_incdec) |
	w_pushcall | i_adiwsbiw | i_call13;
wire t_reg_adr_sel = x_store | x_pushcall | x_out | x_cbi | x_sbi | x_bld | x_bst;
wire [4:0] t_regadr = x_lpm | x_mulall ? 0 : t_reg_adr_sel ? arb0[4:0] : ara0;
reg [3:0] regadr = 0;
always @(posedge clk) if (valid) regadr <= t_regadr[4:1];
FDE wb0(.C(clk), .CE(valid), .D(t_write & t_reg_adr_sel), .Q(we));
FDE wb1(.C(clk), .CE(valid), .D(t_write & (~t_reg_adr_sel | t_isreg_b)), .Q(wreg));
FDE wb2(.C(clk), .CE(valid), .D(t_write & arb0_spl), .Q(load_spl));
FDE wb3(.C(clk), .CE(valid), .D(t_write & arb0_sph), .Q(load_sph));
FDE wb4(.C(clk), .CE(valid), .D(t_write & arb0_sreg | ~force_nop & x_bclrbset), .Q(load_sreg));
FDE wb5(.C(clk), .CE(valid), .D(x_mulall | x_movw | ~t_regadr[0]), .Q(l_ce));
FDE wb6(.C(clk), .CE(valid), .D(x_mulall | x_movw | t_regadr[0]), .Q(h_ce));
wire [7:0] wbdatal0, wbdatah0;
LUT3 LUT3_wbl00(.I2(ix_movw), .I1(rob[0]), .I0(alu_wb[0]), .O(wbdatal0[0]));
defparam LUT3_wbl00.INIT = 'hca;
LUT3 LUT3_wbl01(.I2(ix_movw), .I1(rob[1]), .I0(alu_wb[1]), .O(wbdatal0[1]));
defparam LUT3_wbl01.INIT = 'hca;
LUT3 LUT3_wbl02(.I2(ix_movw), .I1(rob[2]), .I0(alu_wb[2]), .O(wbdatal0[2]));
defparam LUT3_wbl02.INIT = 'hca;
LUT3 LUT3_wbl03(.I2(ix_movw), .I1(rob[3]), .I0(alu_wb[3]), .O(wbdatal0[3]));
defparam LUT3_wbl03.INIT = 'hca;
LUT3 LUT3_wbl04(.I2(ix_movw), .I1(rob[4]), .I0(alu_wb[4]), .O(wbdatal0[4]));
defparam LUT3_wbl04.INIT = 'hca;
LUT3 LUT3_wbl05(.I2(ix_movw), .I1(rob[5]), .I0(alu_wb[5]), .O(wbdatal0[5]));
defparam LUT3_wbl05.INIT = 'hca;
LUT3 LUT3_wbl06(.I2(ix_movw), .I1(rob[6]), .I0(alu_wb[6]), .O(wbdatal0[6]));
defparam LUT3_wbl06.INIT = 'hca;
LUT3 LUT3_wbl07(.I2(ix_movw), .I1(rob[7]), .I0(alu_wb[7]), .O(wbdatal0[7]));
defparam LUT3_wbl07.INIT = 'hca;
LUT3 LUT3_wbh00(.I2(ix_movw), .I1(rob[0 + 8]), .I0(alu_wb[0]), .O(wbdatah0[0]));
defparam LUT3_wbh00.INIT = 'hca;
LUT3 LUT3_wbh01(.I2(ix_movw), .I1(rob[1 + 8]), .I0(alu_wb[1]), .O(wbdatah0[1]));
defparam LUT3_wbh01.INIT = 'hca;
LUT3 LUT3_wbh02(.I2(ix_movw), .I1(rob[2 + 8]), .I0(alu_wb[2]), .O(wbdatah0[2]));
defparam LUT3_wbh02.INIT = 'hca;
LUT3 LUT3_wbh03(.I2(ix_movw), .I1(rob[3 + 8]), .I0(alu_wb[3]), .O(wbdatah0[3]));
defparam LUT3_wbh03.INIT = 'hca;
LUT3 LUT3_wbh04(.I2(ix_movw), .I1(rob[4 + 8]), .I0(alu_wb[4]), .O(wbdatah0[4]));
defparam LUT3_wbh04.INIT = 'hca;
LUT3 LUT3_wbh05(.I2(ix_movw), .I1(rob[5 + 8]), .I0(alu_wb[5]), .O(wbdatah0[5]));
defparam LUT3_wbh05.INIT = 'hca;
LUT3 LUT3_wbh06(.I2(ix_movw), .I1(rob[6 + 8]), .I0(alu_wb[6]), .O(wbdatah0[6]));
defparam LUT3_wbh06.INIT = 'hca;
LUT3 LUT3_wbh07(.I2(ix_movw), .I1(rob[7 + 8]), .I0(alu_wb[7]), .O(wbdatah0[7]));
defparam LUT3_wbh07.INIT = 'hca;
`ifdef MEGA
wire [7:0] wbdatal1, wbdatah1;
wire [7:0] fmuld = { mul_o[6:0], 1'b0 };
LUT3 LUT3_wbl10(.I2(mul2), .I1(fmuld[0]), .I0(mul_o[0]), .O(wbdatal1[0]));
defparam LUT3_wbl10.INIT = 'hca;
LUT3 LUT3_wbl11(.I2(mul2), .I1(fmuld[1]), .I0(mul_o[1]), .O(wbdatal1[1]));
defparam LUT3_wbl11.INIT = 'hca;
LUT3 LUT3_wbl12(.I2(mul2), .I1(fmuld[2]), .I0(mul_o[2]), .O(wbdatal1[2]));
defparam LUT3_wbl12.INIT = 'hca;
LUT3 LUT3_wbl13(.I2(mul2), .I1(fmuld[3]), .I0(mul_o[3]), .O(wbdatal1[3]));
defparam LUT3_wbl13.INIT = 'hca;
LUT3 LUT3_wbl14(.I2(mul2), .I1(fmuld[4]), .I0(mul_o[4]), .O(wbdatal1[4]));
defparam LUT3_wbl14.INIT = 'hca;
LUT3 LUT3_wbl15(.I2(mul2), .I1(fmuld[5]), .I0(mul_o[5]), .O(wbdatal1[5]));
defparam LUT3_wbl15.INIT = 'hca;
LUT3 LUT3_wbl16(.I2(mul2), .I1(fmuld[6]), .I0(mul_o[6]), .O(wbdatal1[6]));
defparam LUT3_wbl16.INIT = 'hca;
LUT3 LUT3_wbl17(.I2(mul2), .I1(fmuld[7]), .I0(mul_o[7]), .O(wbdatal1[7]));
defparam LUT3_wbl17.INIT = 'hca;
LUT3 LUT3_wbh10(.I2(mul2), .I1(mul_o[0 + 7]), .I0(mul_o[0 + 8]), .O(wbdatah1[0]));
defparam LUT3_wbh10.INIT = 'hca;
LUT3 LUT3_wbh11(.I2(mul2), .I1(mul_o[1 + 7]), .I0(mul_o[1 + 8]), .O(wbdatah1[1]));
defparam LUT3_wbh11.INIT = 'hca;
LUT3 LUT3_wbh12(.I2(mul2), .I1(mul_o[2 + 7]), .I0(mul_o[2 + 8]), .O(wbdatah1[2]));
defparam LUT3_wbh12.INIT = 'hca;
LUT3 LUT3_wbh13(.I2(mul2), .I1(mul_o[3 + 7]), .I0(mul_o[3 + 8]), .O(wbdatah1[3]));
defparam LUT3_wbh13.INIT = 'hca;
LUT3 LUT3_wbh14(.I2(mul2), .I1(mul_o[4 + 7]), .I0(mul_o[4 + 8]), .O(wbdatah1[4]));
defparam LUT3_wbh14.INIT = 'hca;
LUT3 LUT3_wbh15(.I2(mul2), .I1(mul_o[5 + 7]), .I0(mul_o[5 + 8]), .O(wbdatah1[5]));
defparam LUT3_wbh15.INIT = 'hca;
LUT3 LUT3_wbh16(.I2(mul2), .I1(mul_o[6 + 7]), .I0(mul_o[6 + 8]), .O(wbdatah1[6]));
defparam LUT3_wbh16.INIT = 'hca;
LUT3 LUT3_wbh17(.I2(mul2), .I1(mul_o[7 + 7]), .I0(mul_o[7 + 8]), .O(wbdatah1[7]));
defparam LUT3_wbh17.INIT = 'hca;
wire [7:0] wbdatal, wbdatah;
MUXF5 MUXF5_wbl0(.S(ix_mulall), .I1(wbdatal1[0]), .I0(wbdatal0[0]), .O(wbdatal[0]));
MUXF5 MUXF5_wbl1(.S(ix_mulall), .I1(wbdatal1[1]), .I0(wbdatal0[1]), .O(wbdatal[1]));
MUXF5 MUXF5_wbl2(.S(ix_mulall), .I1(wbdatal1[2]), .I0(wbdatal0[2]), .O(wbdatal[2]));
MUXF5 MUXF5_wbl3(.S(ix_mulall), .I1(wbdatal1[3]), .I0(wbdatal0[3]), .O(wbdatal[3]));
MUXF5 MUXF5_wbl4(.S(ix_mulall), .I1(wbdatal1[4]), .I0(wbdatal0[4]), .O(wbdatal[4]));
MUXF5 MUXF5_wbl5(.S(ix_mulall), .I1(wbdatal1[5]), .I0(wbdatal0[5]), .O(wbdatal[5]));
MUXF5 MUXF5_wbl6(.S(ix_mulall), .I1(wbdatal1[6]), .I0(wbdatal0[6]), .O(wbdatal[6]));
MUXF5 MUXF5_wbl7(.S(ix_mulall), .I1(wbdatal1[7]), .I0(wbdatal0[7]), .O(wbdatal[7]));
MUXF5 MUXF5_wbh0(.S(ix_mulall), .I1(wbdatah1[0]), .I0(wbdatah0[0]), .O(wbdatah[0]));
MUXF5 MUXF5_wbh1(.S(ix_mulall), .I1(wbdatah1[1]), .I0(wbdatah0[1]), .O(wbdatah[1]));
MUXF5 MUXF5_wbh2(.S(ix_mulall), .I1(wbdatah1[2]), .I0(wbdatah0[2]), .O(wbdatah[2]));
MUXF5 MUXF5_wbh3(.S(ix_mulall), .I1(wbdatah1[3]), .I0(wbdatah0[3]), .O(wbdatah[3]));
MUXF5 MUXF5_wbh4(.S(ix_mulall), .I1(wbdatah1[4]), .I0(wbdatah0[4]), .O(wbdatah[4]));
MUXF5 MUXF5_wbh5(.S(ix_mulall), .I1(wbdatah1[5]), .I0(wbdatah0[5]), .O(wbdatah[5]));
MUXF5 MUXF5_wbh6(.S(ix_mulall), .I1(wbdatah1[6]), .I0(wbdatah0[6]), .O(wbdatah[6]));
MUXF5 MUXF5_wbh7(.S(ix_mulall), .I1(wbdatah1[7]), .I0(wbdatah0[7]), .O(wbdatah[7]));
`else
wire [7:0] wbdatal = wbdatal0, wbdatah = wbdatah0;
`endif
wire update_x = ~force_nop & (x_lsmx | x_lsxp);
wire update_y = ~force_nop & (x_lsmy | x_lsyp);
wire update_z = ~force_nop & (x_lsmz | x_lszp) | i_lpmzp;
wire update_sp = ~force_nop & x_pop | w_pushcall | w_ret | i_ret13;
wire sel_x = wreg & regadr == 'b1101;
wire sel_y = wreg & regadr == 'b1110;
wire sel_z = wreg & regadr == 'b1111;
wire [7:0] ptrl, ptrh;
wire xl_g = update_x;
reg [7:0] xl = 0;
wire [7:0] xl_t, xl_a, xl_d;
wire [8:0] xl_c;
assign xl_c[0] = ~inst[1] & update_x;
MULT_AND mult_and_xl0(.I1(xl_g), .I0(ptrl[0]), .LO(xl_a[0]));
MUXCY muxcy_xl0(.S(xl_t[0]), .DI(xl_a[0]), .CI(xl_c[0]), .O(xl_c[0 + 1]));
XORCY xorcy_xl0(.LI(xl_t[0]), .CI(xl_c[0]), .O(xl_d[0]));
MULT_AND mult_and_xl1(.I1(xl_g), .I0(ptrl[1]), .LO(xl_a[1]));
MUXCY muxcy_xl1(.S(xl_t[1]), .DI(xl_a[1]), .CI(xl_c[1]), .O(xl_c[1 + 1]));
XORCY xorcy_xl1(.LI(xl_t[1]), .CI(xl_c[1]), .O(xl_d[1]));
MULT_AND mult_and_xl2(.I1(xl_g), .I0(ptrl[2]), .LO(xl_a[2]));
MUXCY muxcy_xl2(.S(xl_t[2]), .DI(xl_a[2]), .CI(xl_c[2]), .O(xl_c[2 + 1]));
XORCY xorcy_xl2(.LI(xl_t[2]), .CI(xl_c[2]), .O(xl_d[2]));
MULT_AND mult_and_xl3(.I1(xl_g), .I0(ptrl[3]), .LO(xl_a[3]));
MUXCY muxcy_xl3(.S(xl_t[3]), .DI(xl_a[3]), .CI(xl_c[3]), .O(xl_c[3 + 1]));
XORCY xorcy_xl3(.LI(xl_t[3]), .CI(xl_c[3]), .O(xl_d[3]));
MULT_AND mult_and_xl4(.I1(xl_g), .I0(ptrl[4]), .LO(xl_a[4]));
MUXCY muxcy_xl4(.S(xl_t[4]), .DI(xl_a[4]), .CI(xl_c[4]), .O(xl_c[4 + 1]));
XORCY xorcy_xl4(.LI(xl_t[4]), .CI(xl_c[4]), .O(xl_d[4]));
MULT_AND mult_and_xl5(.I1(xl_g), .I0(ptrl[5]), .LO(xl_a[5]));
MUXCY muxcy_xl5(.S(xl_t[5]), .DI(xl_a[5]), .CI(xl_c[5]), .O(xl_c[5 + 1]));
XORCY xorcy_xl5(.LI(xl_t[5]), .CI(xl_c[5]), .O(xl_d[5]));
MULT_AND mult_and_xl6(.I1(xl_g), .I0(ptrl[6]), .LO(xl_a[6]));
MUXCY muxcy_xl6(.S(xl_t[6]), .DI(xl_a[6]), .CI(xl_c[6]), .O(xl_c[6 + 1]));
XORCY xorcy_xl6(.LI(xl_t[6]), .CI(xl_c[6]), .O(xl_d[6]));
MULT_AND mult_and_xl7(.I1(xl_g), .I0(ptrl[7]), .LO(xl_a[7]));
MUXCY muxcy_xl7(.S(xl_t[7]), .DI(xl_a[7]), .CI(xl_c[7]), .O(xl_c[7 + 1]));
XORCY xorcy_xl7(.LI(xl_t[7]), .CI(xl_c[7]), .O(xl_d[7]));
always @(posedge clk)
	if (valid & (update_x | sel_x & l_ce)) xl <= xl_d;
LUT4 LUT4_xl0(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[0]), .I0(ptrl[0]), .O(xl_t[0]));
defparam LUT4_xl0.INIT = 'h5acc;
LUT4 LUT4_xl1(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[1]), .I0(ptrl[1]), .O(xl_t[1]));
defparam LUT4_xl1.INIT = 'h5acc;
LUT4 LUT4_xl2(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[2]), .I0(ptrl[2]), .O(xl_t[2]));
defparam LUT4_xl2.INIT = 'h5acc;
LUT4 LUT4_xl3(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[3]), .I0(ptrl[3]), .O(xl_t[3]));
defparam LUT4_xl3.INIT = 'h5acc;
LUT4 LUT4_xl4(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[4]), .I0(ptrl[4]), .O(xl_t[4]));
defparam LUT4_xl4.INIT = 'h5acc;
LUT4 LUT4_xl5(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[5]), .I0(ptrl[5]), .O(xl_t[5]));
defparam LUT4_xl5.INIT = 'h5acc;
LUT4 LUT4_xl6(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[6]), .I0(ptrl[6]), .O(xl_t[6]));
defparam LUT4_xl6.INIT = 'h5acc;
LUT4 LUT4_xl7(.I3(update_x), .I2(inst[1]), .I1(wbdatal0[7]), .I0(ptrl[7]), .O(xl_t[7]));
defparam LUT4_xl7.INIT = 'h5acc;
wire xh_g = update_x;
reg [7:0] xh = 0;
wire [7:0] xh_t, xh_a, xh_d;
wire [7:0] xh_c;
assign xh_c[0] = xl_c[8];
MULT_AND mult_and_xh0(.I1(xh_g), .I0(ptrh[0]), .LO(xh_a[0]));
MUXCY muxcy_xh0(.S(xh_t[0]), .DI(xh_a[0]), .CI(xh_c[0]), .O(xh_c[0 + 1]));
XORCY xorcy_xh0(.LI(xh_t[0]), .CI(xh_c[0]), .O(xh_d[0]));
MULT_AND mult_and_xh1(.I1(xh_g), .I0(ptrh[1]), .LO(xh_a[1]));
MUXCY muxcy_xh1(.S(xh_t[1]), .DI(xh_a[1]), .CI(xh_c[1]), .O(xh_c[1 + 1]));
XORCY xorcy_xh1(.LI(xh_t[1]), .CI(xh_c[1]), .O(xh_d[1]));
MULT_AND mult_and_xh2(.I1(xh_g), .I0(ptrh[2]), .LO(xh_a[2]));
MUXCY muxcy_xh2(.S(xh_t[2]), .DI(xh_a[2]), .CI(xh_c[2]), .O(xh_c[2 + 1]));
XORCY xorcy_xh2(.LI(xh_t[2]), .CI(xh_c[2]), .O(xh_d[2]));
MULT_AND mult_and_xh3(.I1(xh_g), .I0(ptrh[3]), .LO(xh_a[3]));
MUXCY muxcy_xh3(.S(xh_t[3]), .DI(xh_a[3]), .CI(xh_c[3]), .O(xh_c[3 + 1]));
XORCY xorcy_xh3(.LI(xh_t[3]), .CI(xh_c[3]), .O(xh_d[3]));
MULT_AND mult_and_xh4(.I1(xh_g), .I0(ptrh[4]), .LO(xh_a[4]));
MUXCY muxcy_xh4(.S(xh_t[4]), .DI(xh_a[4]), .CI(xh_c[4]), .O(xh_c[4 + 1]));
XORCY xorcy_xh4(.LI(xh_t[4]), .CI(xh_c[4]), .O(xh_d[4]));
MULT_AND mult_and_xh5(.I1(xh_g), .I0(ptrh[5]), .LO(xh_a[5]));
MUXCY muxcy_xh5(.S(xh_t[5]), .DI(xh_a[5]), .CI(xh_c[5]), .O(xh_c[5 + 1]));
XORCY xorcy_xh5(.LI(xh_t[5]), .CI(xh_c[5]), .O(xh_d[5]));
MULT_AND mult_and_xh6(.I1(xh_g), .I0(ptrh[6]), .LO(xh_a[6]));
MUXCY muxcy_xh6(.S(xh_t[6]), .DI(xh_a[6]), .CI(xh_c[6]), .O(xh_c[6 + 1]));
XORCY xorcy_xh6(.LI(xh_t[6]), .CI(xh_c[6]), .O(xh_d[6]));
MULT_AND mult_and_xh7(.I1(xh_g), .I0(ptrh[7]), .LO(xh_a[7]));
MUXCY muxcy_xh7(.S(xh_t[7]), .DI(xh_a[7]), .CI(xh_c[7]), .O());
XORCY xorcy_xh7(.LI(xh_t[7]), .CI(xh_c[7]), .O(xh_d[7]));
always @(posedge clk)
	if (valid & (update_x | sel_x & h_ce)) xh <= xh_d;
LUT4 LUT4_xh0(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[0]), .I0(ptrh[0]), .O(xh_t[0]));
defparam LUT4_xh0.INIT = 'h5acc;
LUT4 LUT4_xh1(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[1]), .I0(ptrh[1]), .O(xh_t[1]));
defparam LUT4_xh1.INIT = 'h5acc;
LUT4 LUT4_xh2(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[2]), .I0(ptrh[2]), .O(xh_t[2]));
defparam LUT4_xh2.INIT = 'h5acc;
LUT4 LUT4_xh3(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[3]), .I0(ptrh[3]), .O(xh_t[3]));
defparam LUT4_xh3.INIT = 'h5acc;
LUT4 LUT4_xh4(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[4]), .I0(ptrh[4]), .O(xh_t[4]));
defparam LUT4_xh4.INIT = 'h5acc;
LUT4 LUT4_xh5(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[5]), .I0(ptrh[5]), .O(xh_t[5]));
defparam LUT4_xh5.INIT = 'h5acc;
LUT4 LUT4_xh6(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[6]), .I0(ptrh[6]), .O(xh_t[6]));
defparam LUT4_xh6.INIT = 'h5acc;
LUT4 LUT4_xh7(.I3(update_x), .I2(inst[1]), .I1(wbdatah0[7]), .I0(ptrh[7]), .O(xh_t[7]));
defparam LUT4_xh7.INIT = 'h5acc;
assign x0 = { xh, xl };
wire yl_g = update_y;
reg [7:0] yl = 0;
wire [7:0] yl_t, yl_a, yl_d;
wire [8:0] yl_c;
assign yl_c[0] = ~inst[1] & update_y;
MULT_AND mult_and_yl0(.I1(yl_g), .I0(ptrl[0]), .LO(yl_a[0]));
MUXCY muxcy_yl0(.S(yl_t[0]), .DI(yl_a[0]), .CI(yl_c[0]), .O(yl_c[0 + 1]));
XORCY xorcy_yl0(.LI(yl_t[0]), .CI(yl_c[0]), .O(yl_d[0]));
MULT_AND mult_and_yl1(.I1(yl_g), .I0(ptrl[1]), .LO(yl_a[1]));
MUXCY muxcy_yl1(.S(yl_t[1]), .DI(yl_a[1]), .CI(yl_c[1]), .O(yl_c[1 + 1]));
XORCY xorcy_yl1(.LI(yl_t[1]), .CI(yl_c[1]), .O(yl_d[1]));
MULT_AND mult_and_yl2(.I1(yl_g), .I0(ptrl[2]), .LO(yl_a[2]));
MUXCY muxcy_yl2(.S(yl_t[2]), .DI(yl_a[2]), .CI(yl_c[2]), .O(yl_c[2 + 1]));
XORCY xorcy_yl2(.LI(yl_t[2]), .CI(yl_c[2]), .O(yl_d[2]));
MULT_AND mult_and_yl3(.I1(yl_g), .I0(ptrl[3]), .LO(yl_a[3]));
MUXCY muxcy_yl3(.S(yl_t[3]), .DI(yl_a[3]), .CI(yl_c[3]), .O(yl_c[3 + 1]));
XORCY xorcy_yl3(.LI(yl_t[3]), .CI(yl_c[3]), .O(yl_d[3]));
MULT_AND mult_and_yl4(.I1(yl_g), .I0(ptrl[4]), .LO(yl_a[4]));
MUXCY muxcy_yl4(.S(yl_t[4]), .DI(yl_a[4]), .CI(yl_c[4]), .O(yl_c[4 + 1]));
XORCY xorcy_yl4(.LI(yl_t[4]), .CI(yl_c[4]), .O(yl_d[4]));
MULT_AND mult_and_yl5(.I1(yl_g), .I0(ptrl[5]), .LO(yl_a[5]));
MUXCY muxcy_yl5(.S(yl_t[5]), .DI(yl_a[5]), .CI(yl_c[5]), .O(yl_c[5 + 1]));
XORCY xorcy_yl5(.LI(yl_t[5]), .CI(yl_c[5]), .O(yl_d[5]));
MULT_AND mult_and_yl6(.I1(yl_g), .I0(ptrl[6]), .LO(yl_a[6]));
MUXCY muxcy_yl6(.S(yl_t[6]), .DI(yl_a[6]), .CI(yl_c[6]), .O(yl_c[6 + 1]));
XORCY xorcy_yl6(.LI(yl_t[6]), .CI(yl_c[6]), .O(yl_d[6]));
MULT_AND mult_and_yl7(.I1(yl_g), .I0(ptrl[7]), .LO(yl_a[7]));
MUXCY muxcy_yl7(.S(yl_t[7]), .DI(yl_a[7]), .CI(yl_c[7]), .O(yl_c[7 + 1]));
XORCY xorcy_yl7(.LI(yl_t[7]), .CI(yl_c[7]), .O(yl_d[7]));
always @(posedge clk)
	if (valid & (update_y | sel_y & l_ce)) yl <= yl_d;
LUT4 LUT4_yl0(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[0]), .I0(ptrl[0]), .O(yl_t[0]));
defparam LUT4_yl0.INIT = 'h5acc;
LUT4 LUT4_yl1(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[1]), .I0(ptrl[1]), .O(yl_t[1]));
defparam LUT4_yl1.INIT = 'h5acc;
LUT4 LUT4_yl2(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[2]), .I0(ptrl[2]), .O(yl_t[2]));
defparam LUT4_yl2.INIT = 'h5acc;
LUT4 LUT4_yl3(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[3]), .I0(ptrl[3]), .O(yl_t[3]));
defparam LUT4_yl3.INIT = 'h5acc;
LUT4 LUT4_yl4(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[4]), .I0(ptrl[4]), .O(yl_t[4]));
defparam LUT4_yl4.INIT = 'h5acc;
LUT4 LUT4_yl5(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[5]), .I0(ptrl[5]), .O(yl_t[5]));
defparam LUT4_yl5.INIT = 'h5acc;
LUT4 LUT4_yl6(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[6]), .I0(ptrl[6]), .O(yl_t[6]));
defparam LUT4_yl6.INIT = 'h5acc;
LUT4 LUT4_yl7(.I3(update_y), .I2(inst[1]), .I1(wbdatal0[7]), .I0(ptrl[7]), .O(yl_t[7]));
defparam LUT4_yl7.INIT = 'h5acc;
wire yh_g = update_y;
reg [7:0] yh = 0;
wire [7:0] yh_t, yh_a, yh_d;
wire [7:0] yh_c;
assign yh_c[0] = yl_c[8];
MULT_AND mult_and_yh0(.I1(yh_g), .I0(ptrh[0]), .LO(yh_a[0]));
MUXCY muxcy_yh0(.S(yh_t[0]), .DI(yh_a[0]), .CI(yh_c[0]), .O(yh_c[0 + 1]));
XORCY xorcy_yh0(.LI(yh_t[0]), .CI(yh_c[0]), .O(yh_d[0]));
MULT_AND mult_and_yh1(.I1(yh_g), .I0(ptrh[1]), .LO(yh_a[1]));
MUXCY muxcy_yh1(.S(yh_t[1]), .DI(yh_a[1]), .CI(yh_c[1]), .O(yh_c[1 + 1]));
XORCY xorcy_yh1(.LI(yh_t[1]), .CI(yh_c[1]), .O(yh_d[1]));
MULT_AND mult_and_yh2(.I1(yh_g), .I0(ptrh[2]), .LO(yh_a[2]));
MUXCY muxcy_yh2(.S(yh_t[2]), .DI(yh_a[2]), .CI(yh_c[2]), .O(yh_c[2 + 1]));
XORCY xorcy_yh2(.LI(yh_t[2]), .CI(yh_c[2]), .O(yh_d[2]));
MULT_AND mult_and_yh3(.I1(yh_g), .I0(ptrh[3]), .LO(yh_a[3]));
MUXCY muxcy_yh3(.S(yh_t[3]), .DI(yh_a[3]), .CI(yh_c[3]), .O(yh_c[3 + 1]));
XORCY xorcy_yh3(.LI(yh_t[3]), .CI(yh_c[3]), .O(yh_d[3]));
MULT_AND mult_and_yh4(.I1(yh_g), .I0(ptrh[4]), .LO(yh_a[4]));
MUXCY muxcy_yh4(.S(yh_t[4]), .DI(yh_a[4]), .CI(yh_c[4]), .O(yh_c[4 + 1]));
XORCY xorcy_yh4(.LI(yh_t[4]), .CI(yh_c[4]), .O(yh_d[4]));
MULT_AND mult_and_yh5(.I1(yh_g), .I0(ptrh[5]), .LO(yh_a[5]));
MUXCY muxcy_yh5(.S(yh_t[5]), .DI(yh_a[5]), .CI(yh_c[5]), .O(yh_c[5 + 1]));
XORCY xorcy_yh5(.LI(yh_t[5]), .CI(yh_c[5]), .O(yh_d[5]));
MULT_AND mult_and_yh6(.I1(yh_g), .I0(ptrh[6]), .LO(yh_a[6]));
MUXCY muxcy_yh6(.S(yh_t[6]), .DI(yh_a[6]), .CI(yh_c[6]), .O(yh_c[6 + 1]));
XORCY xorcy_yh6(.LI(yh_t[6]), .CI(yh_c[6]), .O(yh_d[6]));
MULT_AND mult_and_yh7(.I1(yh_g), .I0(ptrh[7]), .LO(yh_a[7]));
MUXCY muxcy_yh7(.S(yh_t[7]), .DI(yh_a[7]), .CI(yh_c[7]), .O());
XORCY xorcy_yh7(.LI(yh_t[7]), .CI(yh_c[7]), .O(yh_d[7]));
always @(posedge clk)
	if (valid & (update_y | sel_y & h_ce)) yh <= yh_d;
LUT4 LUT4_yh0(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[0]), .I0(ptrh[0]), .O(yh_t[0]));
defparam LUT4_yh0.INIT = 'h5acc;
LUT4 LUT4_yh1(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[1]), .I0(ptrh[1]), .O(yh_t[1]));
defparam LUT4_yh1.INIT = 'h5acc;
LUT4 LUT4_yh2(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[2]), .I0(ptrh[2]), .O(yh_t[2]));
defparam LUT4_yh2.INIT = 'h5acc;
LUT4 LUT4_yh3(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[3]), .I0(ptrh[3]), .O(yh_t[3]));
defparam LUT4_yh3.INIT = 'h5acc;
LUT4 LUT4_yh4(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[4]), .I0(ptrh[4]), .O(yh_t[4]));
defparam LUT4_yh4.INIT = 'h5acc;
LUT4 LUT4_yh5(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[5]), .I0(ptrh[5]), .O(yh_t[5]));
defparam LUT4_yh5.INIT = 'h5acc;
LUT4 LUT4_yh6(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[6]), .I0(ptrh[6]), .O(yh_t[6]));
defparam LUT4_yh6.INIT = 'h5acc;
LUT4 LUT4_yh7(.I3(update_y), .I2(inst[1]), .I1(wbdatah0[7]), .I0(ptrh[7]), .O(yh_t[7]));
defparam LUT4_yh7.INIT = 'h5acc;
assign y0 = { yh, yl };
wire zm = inst[1] & ~i_lpmzp;
wire zl_g = update_z;
reg [7:0] zl = 0;
wire [7:0] zl_t, zl_a, zl_d;
wire [8:0] zl_c;
assign zl_c[0] = ~zm & update_z;
MULT_AND mult_and_zl0(.I1(zl_g), .I0(ptrl[0]), .LO(zl_a[0]));
MUXCY muxcy_zl0(.S(zl_t[0]), .DI(zl_a[0]), .CI(zl_c[0]), .O(zl_c[0 + 1]));
XORCY xorcy_zl0(.LI(zl_t[0]), .CI(zl_c[0]), .O(zl_d[0]));
MULT_AND mult_and_zl1(.I1(zl_g), .I0(ptrl[1]), .LO(zl_a[1]));
MUXCY muxcy_zl1(.S(zl_t[1]), .DI(zl_a[1]), .CI(zl_c[1]), .O(zl_c[1 + 1]));
XORCY xorcy_zl1(.LI(zl_t[1]), .CI(zl_c[1]), .O(zl_d[1]));
MULT_AND mult_and_zl2(.I1(zl_g), .I0(ptrl[2]), .LO(zl_a[2]));
MUXCY muxcy_zl2(.S(zl_t[2]), .DI(zl_a[2]), .CI(zl_c[2]), .O(zl_c[2 + 1]));
XORCY xorcy_zl2(.LI(zl_t[2]), .CI(zl_c[2]), .O(zl_d[2]));
MULT_AND mult_and_zl3(.I1(zl_g), .I0(ptrl[3]), .LO(zl_a[3]));
MUXCY muxcy_zl3(.S(zl_t[3]), .DI(zl_a[3]), .CI(zl_c[3]), .O(zl_c[3 + 1]));
XORCY xorcy_zl3(.LI(zl_t[3]), .CI(zl_c[3]), .O(zl_d[3]));
MULT_AND mult_and_zl4(.I1(zl_g), .I0(ptrl[4]), .LO(zl_a[4]));
MUXCY muxcy_zl4(.S(zl_t[4]), .DI(zl_a[4]), .CI(zl_c[4]), .O(zl_c[4 + 1]));
XORCY xorcy_zl4(.LI(zl_t[4]), .CI(zl_c[4]), .O(zl_d[4]));
MULT_AND mult_and_zl5(.I1(zl_g), .I0(ptrl[5]), .LO(zl_a[5]));
MUXCY muxcy_zl5(.S(zl_t[5]), .DI(zl_a[5]), .CI(zl_c[5]), .O(zl_c[5 + 1]));
XORCY xorcy_zl5(.LI(zl_t[5]), .CI(zl_c[5]), .O(zl_d[5]));
MULT_AND mult_and_zl6(.I1(zl_g), .I0(ptrl[6]), .LO(zl_a[6]));
MUXCY muxcy_zl6(.S(zl_t[6]), .DI(zl_a[6]), .CI(zl_c[6]), .O(zl_c[6 + 1]));
XORCY xorcy_zl6(.LI(zl_t[6]), .CI(zl_c[6]), .O(zl_d[6]));
MULT_AND mult_and_zl7(.I1(zl_g), .I0(ptrl[7]), .LO(zl_a[7]));
MUXCY muxcy_zl7(.S(zl_t[7]), .DI(zl_a[7]), .CI(zl_c[7]), .O(zl_c[7 + 1]));
XORCY xorcy_zl7(.LI(zl_t[7]), .CI(zl_c[7]), .O(zl_d[7]));
always @(posedge clk)
	if (valid & (update_z | sel_z & l_ce)) zl <= zl_d;
LUT4 LUT4_zl0(.I3(update_z), .I2(zm), .I1(wbdatal0[0]), .I0(ptrl[0]), .O(zl_t[0]));
defparam LUT4_zl0.INIT = 'h5acc;
LUT4 LUT4_zl1(.I3(update_z), .I2(zm), .I1(wbdatal0[1]), .I0(ptrl[1]), .O(zl_t[1]));
defparam LUT4_zl1.INIT = 'h5acc;
LUT4 LUT4_zl2(.I3(update_z), .I2(zm), .I1(wbdatal0[2]), .I0(ptrl[2]), .O(zl_t[2]));
defparam LUT4_zl2.INIT = 'h5acc;
LUT4 LUT4_zl3(.I3(update_z), .I2(zm), .I1(wbdatal0[3]), .I0(ptrl[3]), .O(zl_t[3]));
defparam LUT4_zl3.INIT = 'h5acc;
LUT4 LUT4_zl4(.I3(update_z), .I2(zm), .I1(wbdatal0[4]), .I0(ptrl[4]), .O(zl_t[4]));
defparam LUT4_zl4.INIT = 'h5acc;
LUT4 LUT4_zl5(.I3(update_z), .I2(zm), .I1(wbdatal0[5]), .I0(ptrl[5]), .O(zl_t[5]));
defparam LUT4_zl5.INIT = 'h5acc;
LUT4 LUT4_zl6(.I3(update_z), .I2(zm), .I1(wbdatal0[6]), .I0(ptrl[6]), .O(zl_t[6]));
defparam LUT4_zl6.INIT = 'h5acc;
LUT4 LUT4_zl7(.I3(update_z), .I2(zm), .I1(wbdatal0[7]), .I0(ptrl[7]), .O(zl_t[7]));
defparam LUT4_zl7.INIT = 'h5acc;
wire zh_g = update_z;
reg [7:0] zh = 0;
wire [7:0] zh_t, zh_a, zh_d;
wire [8:0] zh_c;
assign zh_c[0] = zl_c[8];
MULT_AND mult_and_zh0(.I1(zh_g), .I0(ptrh[0]), .LO(zh_a[0]));
MUXCY muxcy_zh0(.S(zh_t[0]), .DI(zh_a[0]), .CI(zh_c[0]), .O(zh_c[0 + 1]));
XORCY xorcy_zh0(.LI(zh_t[0]), .CI(zh_c[0]), .O(zh_d[0]));
MULT_AND mult_and_zh1(.I1(zh_g), .I0(ptrh[1]), .LO(zh_a[1]));
MUXCY muxcy_zh1(.S(zh_t[1]), .DI(zh_a[1]), .CI(zh_c[1]), .O(zh_c[1 + 1]));
XORCY xorcy_zh1(.LI(zh_t[1]), .CI(zh_c[1]), .O(zh_d[1]));
MULT_AND mult_and_zh2(.I1(zh_g), .I0(ptrh[2]), .LO(zh_a[2]));
MUXCY muxcy_zh2(.S(zh_t[2]), .DI(zh_a[2]), .CI(zh_c[2]), .O(zh_c[2 + 1]));
XORCY xorcy_zh2(.LI(zh_t[2]), .CI(zh_c[2]), .O(zh_d[2]));
MULT_AND mult_and_zh3(.I1(zh_g), .I0(ptrh[3]), .LO(zh_a[3]));
MUXCY muxcy_zh3(.S(zh_t[3]), .DI(zh_a[3]), .CI(zh_c[3]), .O(zh_c[3 + 1]));
XORCY xorcy_zh3(.LI(zh_t[3]), .CI(zh_c[3]), .O(zh_d[3]));
MULT_AND mult_and_zh4(.I1(zh_g), .I0(ptrh[4]), .LO(zh_a[4]));
MUXCY muxcy_zh4(.S(zh_t[4]), .DI(zh_a[4]), .CI(zh_c[4]), .O(zh_c[4 + 1]));
XORCY xorcy_zh4(.LI(zh_t[4]), .CI(zh_c[4]), .O(zh_d[4]));
MULT_AND mult_and_zh5(.I1(zh_g), .I0(ptrh[5]), .LO(zh_a[5]));
MUXCY muxcy_zh5(.S(zh_t[5]), .DI(zh_a[5]), .CI(zh_c[5]), .O(zh_c[5 + 1]));
XORCY xorcy_zh5(.LI(zh_t[5]), .CI(zh_c[5]), .O(zh_d[5]));
MULT_AND mult_and_zh6(.I1(zh_g), .I0(ptrh[6]), .LO(zh_a[6]));
MUXCY muxcy_zh6(.S(zh_t[6]), .DI(zh_a[6]), .CI(zh_c[6]), .O(zh_c[6 + 1]));
XORCY xorcy_zh6(.LI(zh_t[6]), .CI(zh_c[6]), .O(zh_d[6]));
MULT_AND mult_and_zh7(.I1(zh_g), .I0(ptrh[7]), .LO(zh_a[7]));
MUXCY muxcy_zh7(.S(zh_t[7]), .DI(zh_a[7]), .CI(zh_c[7]), .O(zh_c[7 + 1]));
XORCY xorcy_zh7(.LI(zh_t[7]), .CI(zh_c[7]), .O(zh_d[7]));
always @(posedge clk)
	if (valid & (update_z | sel_z & h_ce)) zh <= zh_d;
LUT4 LUT4_zh0(.I3(update_z), .I2(zm), .I1(wbdatah0[0]), .I0(ptrh[0]), .O(zh_t[0]));
defparam LUT4_zh0.INIT = 'h5acc;
LUT4 LUT4_zh1(.I3(update_z), .I2(zm), .I1(wbdatah0[1]), .I0(ptrh[1]), .O(zh_t[1]));
defparam LUT4_zh1.INIT = 'h5acc;
LUT4 LUT4_zh2(.I3(update_z), .I2(zm), .I1(wbdatah0[2]), .I0(ptrh[2]), .O(zh_t[2]));
defparam LUT4_zh2.INIT = 'h5acc;
LUT4 LUT4_zh3(.I3(update_z), .I2(zm), .I1(wbdatah0[3]), .I0(ptrh[3]), .O(zh_t[3]));
defparam LUT4_zh3.INIT = 'h5acc;
LUT4 LUT4_zh4(.I3(update_z), .I2(zm), .I1(wbdatah0[4]), .I0(ptrh[4]), .O(zh_t[4]));
defparam LUT4_zh4.INIT = 'h5acc;
LUT4 LUT4_zh5(.I3(update_z), .I2(zm), .I1(wbdatah0[5]), .I0(ptrh[5]), .O(zh_t[5]));
defparam LUT4_zh5.INIT = 'h5acc;
LUT4 LUT4_zh6(.I3(update_z), .I2(zm), .I1(wbdatah0[6]), .I0(ptrh[6]), .O(zh_t[6]));
defparam LUT4_zh6.INIT = 'h5acc;
LUT4 LUT4_zh7(.I3(update_z), .I2(zm), .I1(wbdatah0[7]), .I0(ptrh[7]), .O(zh_t[7]));
defparam LUT4_zh7.INIT = 'h5acc;
`ifdef ELPM
wire load_rampz;
FDE wb7(.C(clk), .CE(valid), .D(t_write & arb0 == 'h5b), .Q(load_rampz));
FDE wb8(.C(clk), .CE(valid), .D(f_elpm), .Q(elpm));
wire rampz_g = update_z;
reg [0:0] rampz = 0;
wire [0:0] rampz_t, rampz_a, rampz_d;
wire [0:0] rampz_c;
assign rampz_c[0] = zh_c[8] & elpm;
MULT_AND mult_and_rampz0(.I1(rampz_g), .I0(rampz[0]), .LO(rampz_a[0]));
MUXCY muxcy_rampz0(.S(rampz_t[0]), .DI(rampz_a[0]), .CI(rampz_c[0]), .O());
XORCY xorcy_rampz0(.LI(rampz_t[0]), .CI(rampz_c[0]), .O(rampz_d[0]));
always @(posedge clk)
	if (valid & (update_z | load_rampz)) rampz <= rampz_d;
LUT3 LUT3_rampz0(.I2(update_z), .I1(alu_y[0]), .I0(rampz[0]), .O(rampz_t[0]));
defparam LUT3_rampz0.INIT = 'hac;
assign forward_rampz = f_elpm ? load_rampz ? alu_y : rampz : 0;
`endif
assign z0 = { zh, zl };
wire spl_g = update_sp;
reg [7:0] spl = 0;
wire [7:0] spl_t, spl_a, spl_d;
wire [8:0] spl_c;
assign spl_c[0] = ~x_pushcall & update_sp;
MULT_AND mult_and_spl0(.I1(spl_g), .I0(ptrl[0]), .LO(spl_a[0]));
MUXCY muxcy_spl0(.S(spl_t[0]), .DI(spl_a[0]), .CI(spl_c[0]), .O(spl_c[0 + 1]));
XORCY xorcy_spl0(.LI(spl_t[0]), .CI(spl_c[0]), .O(spl_d[0]));
MULT_AND mult_and_spl1(.I1(spl_g), .I0(ptrl[1]), .LO(spl_a[1]));
MUXCY muxcy_spl1(.S(spl_t[1]), .DI(spl_a[1]), .CI(spl_c[1]), .O(spl_c[1 + 1]));
XORCY xorcy_spl1(.LI(spl_t[1]), .CI(spl_c[1]), .O(spl_d[1]));
MULT_AND mult_and_spl2(.I1(spl_g), .I0(ptrl[2]), .LO(spl_a[2]));
MUXCY muxcy_spl2(.S(spl_t[2]), .DI(spl_a[2]), .CI(spl_c[2]), .O(spl_c[2 + 1]));
XORCY xorcy_spl2(.LI(spl_t[2]), .CI(spl_c[2]), .O(spl_d[2]));
MULT_AND mult_and_spl3(.I1(spl_g), .I0(ptrl[3]), .LO(spl_a[3]));
MUXCY muxcy_spl3(.S(spl_t[3]), .DI(spl_a[3]), .CI(spl_c[3]), .O(spl_c[3 + 1]));
XORCY xorcy_spl3(.LI(spl_t[3]), .CI(spl_c[3]), .O(spl_d[3]));
MULT_AND mult_and_spl4(.I1(spl_g), .I0(ptrl[4]), .LO(spl_a[4]));
MUXCY muxcy_spl4(.S(spl_t[4]), .DI(spl_a[4]), .CI(spl_c[4]), .O(spl_c[4 + 1]));
XORCY xorcy_spl4(.LI(spl_t[4]), .CI(spl_c[4]), .O(spl_d[4]));
MULT_AND mult_and_spl5(.I1(spl_g), .I0(ptrl[5]), .LO(spl_a[5]));
MUXCY muxcy_spl5(.S(spl_t[5]), .DI(spl_a[5]), .CI(spl_c[5]), .O(spl_c[5 + 1]));
XORCY xorcy_spl5(.LI(spl_t[5]), .CI(spl_c[5]), .O(spl_d[5]));
MULT_AND mult_and_spl6(.I1(spl_g), .I0(ptrl[6]), .LO(spl_a[6]));
MUXCY muxcy_spl6(.S(spl_t[6]), .DI(spl_a[6]), .CI(spl_c[6]), .O(spl_c[6 + 1]));
XORCY xorcy_spl6(.LI(spl_t[6]), .CI(spl_c[6]), .O(spl_d[6]));
MULT_AND mult_and_spl7(.I1(spl_g), .I0(ptrl[7]), .LO(spl_a[7]));
MUXCY muxcy_spl7(.S(spl_t[7]), .DI(spl_a[7]), .CI(spl_c[7]), .O(spl_c[7 + 1]));
XORCY xorcy_spl7(.LI(spl_t[7]), .CI(spl_c[7]), .O(spl_d[7]));
always @(posedge clk)
	if (valid & (update_sp | load_spl)) spl <= spl_d;
LUT4 LUT4_spl0(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[0]), .I0(ptrl[0]), .O(spl_t[0]));
defparam LUT4_spl0.INIT = 'h5acc;
LUT4 LUT4_spl1(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[1]), .I0(ptrl[1]), .O(spl_t[1]));
defparam LUT4_spl1.INIT = 'h5acc;
LUT4 LUT4_spl2(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[2]), .I0(ptrl[2]), .O(spl_t[2]));
defparam LUT4_spl2.INIT = 'h5acc;
LUT4 LUT4_spl3(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[3]), .I0(ptrl[3]), .O(spl_t[3]));
defparam LUT4_spl3.INIT = 'h5acc;
LUT4 LUT4_spl4(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[4]), .I0(ptrl[4]), .O(spl_t[4]));
defparam LUT4_spl4.INIT = 'h5acc;
LUT4 LUT4_spl5(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[5]), .I0(ptrl[5]), .O(spl_t[5]));
defparam LUT4_spl5.INIT = 'h5acc;
LUT4 LUT4_spl6(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[6]), .I0(ptrl[6]), .O(spl_t[6]));
defparam LUT4_spl6.INIT = 'h5acc;
LUT4 LUT4_spl7(.I3(update_sp), .I2(x_pushcall), .I1(wbdatal0[7]), .I0(ptrl[7]), .O(spl_t[7]));
defparam LUT4_spl7.INIT = 'h5acc;
wire sph_g = update_sp;
reg [7:0] sph = 0;
wire [7:0] sph_t, sph_a, sph_d;
wire [7:0] sph_c;
assign sph_c[0] = spl_c[8];
MULT_AND mult_and_sph0(.I1(sph_g), .I0(ptrh[0]), .LO(sph_a[0]));
MUXCY muxcy_sph0(.S(sph_t[0]), .DI(sph_a[0]), .CI(sph_c[0]), .O(sph_c[0 + 1]));
XORCY xorcy_sph0(.LI(sph_t[0]), .CI(sph_c[0]), .O(sph_d[0]));
MULT_AND mult_and_sph1(.I1(sph_g), .I0(ptrh[1]), .LO(sph_a[1]));
MUXCY muxcy_sph1(.S(sph_t[1]), .DI(sph_a[1]), .CI(sph_c[1]), .O(sph_c[1 + 1]));
XORCY xorcy_sph1(.LI(sph_t[1]), .CI(sph_c[1]), .O(sph_d[1]));
MULT_AND mult_and_sph2(.I1(sph_g), .I0(ptrh[2]), .LO(sph_a[2]));
MUXCY muxcy_sph2(.S(sph_t[2]), .DI(sph_a[2]), .CI(sph_c[2]), .O(sph_c[2 + 1]));
XORCY xorcy_sph2(.LI(sph_t[2]), .CI(sph_c[2]), .O(sph_d[2]));
MULT_AND mult_and_sph3(.I1(sph_g), .I0(ptrh[3]), .LO(sph_a[3]));
MUXCY muxcy_sph3(.S(sph_t[3]), .DI(sph_a[3]), .CI(sph_c[3]), .O(sph_c[3 + 1]));
XORCY xorcy_sph3(.LI(sph_t[3]), .CI(sph_c[3]), .O(sph_d[3]));
MULT_AND mult_and_sph4(.I1(sph_g), .I0(ptrh[4]), .LO(sph_a[4]));
MUXCY muxcy_sph4(.S(sph_t[4]), .DI(sph_a[4]), .CI(sph_c[4]), .O(sph_c[4 + 1]));
XORCY xorcy_sph4(.LI(sph_t[4]), .CI(sph_c[4]), .O(sph_d[4]));
MULT_AND mult_and_sph5(.I1(sph_g), .I0(ptrh[5]), .LO(sph_a[5]));
MUXCY muxcy_sph5(.S(sph_t[5]), .DI(sph_a[5]), .CI(sph_c[5]), .O(sph_c[5 + 1]));
XORCY xorcy_sph5(.LI(sph_t[5]), .CI(sph_c[5]), .O(sph_d[5]));
MULT_AND mult_and_sph6(.I1(sph_g), .I0(ptrh[6]), .LO(sph_a[6]));
MUXCY muxcy_sph6(.S(sph_t[6]), .DI(sph_a[6]), .CI(sph_c[6]), .O(sph_c[6 + 1]));
XORCY xorcy_sph6(.LI(sph_t[6]), .CI(sph_c[6]), .O(sph_d[6]));
MULT_AND mult_and_sph7(.I1(sph_g), .I0(ptrh[7]), .LO(sph_a[7]));
MUXCY muxcy_sph7(.S(sph_t[7]), .DI(sph_a[7]), .CI(sph_c[7]), .O());
XORCY xorcy_sph7(.LI(sph_t[7]), .CI(sph_c[7]), .O(sph_d[7]));
always @(posedge clk)
	if (valid & (update_sp | load_sph)) sph <= sph_d;
LUT4 LUT4_sph0(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[0]), .I0(ptrh[0]), .O(sph_t[0]));
defparam LUT4_sph0.INIT = 'h5acc;
LUT4 LUT4_sph1(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[1]), .I0(ptrh[1]), .O(sph_t[1]));
defparam LUT4_sph1.INIT = 'h5acc;
LUT4 LUT4_sph2(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[2]), .I0(ptrh[2]), .O(sph_t[2]));
defparam LUT4_sph2.INIT = 'h5acc;
LUT4 LUT4_sph3(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[3]), .I0(ptrh[3]), .O(sph_t[3]));
defparam LUT4_sph3.INIT = 'h5acc;
LUT4 LUT4_sph4(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[4]), .I0(ptrh[4]), .O(sph_t[4]));
defparam LUT4_sph4.INIT = 'h5acc;
LUT4 LUT4_sph5(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[5]), .I0(ptrh[5]), .O(sph_t[5]));
defparam LUT4_sph5.INIT = 'h5acc;
LUT4 LUT4_sph6(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[6]), .I0(ptrh[6]), .O(sph_t[6]));
defparam LUT4_sph6.INIT = 'h5acc;
LUT4 LUT4_sph7(.I3(update_sp), .I2(x_pushcall), .I1(wbdatah0[7]), .I0(ptrh[7]), .O(sph_t[7]));
defparam LUT4_sph7.INIT = 'h5acc;
assign sp0 = { sph, spl };
always @(posedge clk) if (valid & wreg) begin
	if (l_ce) rl[regadr] <= wbdatal;
	if (h_ce) rh[regadr] <= wbdatah;
end
wire [1:0] ptradr = {
	i_lpmzp | ~indirect_sp & (~inst[12] | inst[3:2] != 'b11),
	i_lpmzp | ~indirect_sp & (inst[12] ? inst[3:2] != 'b10 : ~inst[3])
};
	function [7:0] sel8x4;
		input [1:0] sel;
		input [31:0] a;
		case (sel)
			0: sel8x4 = a[7:0];
			1: sel8x4 = a[15:8];
			2: sel8x4 = a[23:16];
			3: sel8x4 = a[31:24];
		endcase
	endfunction
wire [7:0] sph_e = sph;
wire [7:0] ptr0l = sel8x4(ptradr, { zl, yl, xl, spl });
wire [7:0] ptr0h = sel8x4(ptradr, { zh, yh, xh, sph_e });
wire fg = wreg & &regadr[3:2] & |regadr[1:0] & regadr[1:0] == ptradr;
assign ptrl = fg & l_ce ? wbdatal0 : ptr0l;
assign ptrh = fg & h_ce ? wbdatah0 : ptr0h;
assign ptr = { ptrh, ptrl };
assign forward_z = { sel_z & h_ce ? wbdatah0 : zh, sel_z & l_ce ? wbdatal0 : zl };
reg [15:0] pc_call = 0;
wire [15:0] pc_call_t, pc_call_a, pc_call_d;
wire [15:0] pc_call_c;
assign pc_call_c[0] = w_call;
assign pc_call_a = pcreg;
MUXCY muxcy_pc_call0(.S(pc_call_t[0]), .DI(pc_call_a[0]), .CI(pc_call_c[0]), .O(pc_call_c[0 + 1]));
XORCY xorcy_pc_call0(.LI(pc_call_t[0]), .CI(pc_call_c[0]), .O(pc_call_d[0]));
MUXCY muxcy_pc_call1(.S(pc_call_t[1]), .DI(pc_call_a[1]), .CI(pc_call_c[1]), .O(pc_call_c[1 + 1]));
XORCY xorcy_pc_call1(.LI(pc_call_t[1]), .CI(pc_call_c[1]), .O(pc_call_d[1]));
MUXCY muxcy_pc_call2(.S(pc_call_t[2]), .DI(pc_call_a[2]), .CI(pc_call_c[2]), .O(pc_call_c[2 + 1]));
XORCY xorcy_pc_call2(.LI(pc_call_t[2]), .CI(pc_call_c[2]), .O(pc_call_d[2]));
MUXCY muxcy_pc_call3(.S(pc_call_t[3]), .DI(pc_call_a[3]), .CI(pc_call_c[3]), .O(pc_call_c[3 + 1]));
XORCY xorcy_pc_call3(.LI(pc_call_t[3]), .CI(pc_call_c[3]), .O(pc_call_d[3]));
MUXCY muxcy_pc_call4(.S(pc_call_t[4]), .DI(pc_call_a[4]), .CI(pc_call_c[4]), .O(pc_call_c[4 + 1]));
XORCY xorcy_pc_call4(.LI(pc_call_t[4]), .CI(pc_call_c[4]), .O(pc_call_d[4]));
MUXCY muxcy_pc_call5(.S(pc_call_t[5]), .DI(pc_call_a[5]), .CI(pc_call_c[5]), .O(pc_call_c[5 + 1]));
XORCY xorcy_pc_call5(.LI(pc_call_t[5]), .CI(pc_call_c[5]), .O(pc_call_d[5]));
MUXCY muxcy_pc_call6(.S(pc_call_t[6]), .DI(pc_call_a[6]), .CI(pc_call_c[6]), .O(pc_call_c[6 + 1]));
XORCY xorcy_pc_call6(.LI(pc_call_t[6]), .CI(pc_call_c[6]), .O(pc_call_d[6]));
MUXCY muxcy_pc_call7(.S(pc_call_t[7]), .DI(pc_call_a[7]), .CI(pc_call_c[7]), .O(pc_call_c[7 + 1]));
XORCY xorcy_pc_call7(.LI(pc_call_t[7]), .CI(pc_call_c[7]), .O(pc_call_d[7]));
MUXCY muxcy_pc_call8(.S(pc_call_t[8]), .DI(pc_call_a[8]), .CI(pc_call_c[8]), .O(pc_call_c[8 + 1]));
XORCY xorcy_pc_call8(.LI(pc_call_t[8]), .CI(pc_call_c[8]), .O(pc_call_d[8]));
MUXCY muxcy_pc_call9(.S(pc_call_t[9]), .DI(pc_call_a[9]), .CI(pc_call_c[9]), .O(pc_call_c[9 + 1]));
XORCY xorcy_pc_call9(.LI(pc_call_t[9]), .CI(pc_call_c[9]), .O(pc_call_d[9]));
MUXCY muxcy_pc_call10(.S(pc_call_t[10]), .DI(pc_call_a[10]), .CI(pc_call_c[10]), .O(pc_call_c[10 + 1]));
XORCY xorcy_pc_call10(.LI(pc_call_t[10]), .CI(pc_call_c[10]), .O(pc_call_d[10]));
MUXCY muxcy_pc_call11(.S(pc_call_t[11]), .DI(pc_call_a[11]), .CI(pc_call_c[11]), .O(pc_call_c[11 + 1]));
XORCY xorcy_pc_call11(.LI(pc_call_t[11]), .CI(pc_call_c[11]), .O(pc_call_d[11]));
MUXCY muxcy_pc_call12(.S(pc_call_t[12]), .DI(pc_call_a[12]), .CI(pc_call_c[12]), .O(pc_call_c[12 + 1]));
XORCY xorcy_pc_call12(.LI(pc_call_t[12]), .CI(pc_call_c[12]), .O(pc_call_d[12]));
MUXCY muxcy_pc_call13(.S(pc_call_t[13]), .DI(pc_call_a[13]), .CI(pc_call_c[13]), .O(pc_call_c[13 + 1]));
XORCY xorcy_pc_call13(.LI(pc_call_t[13]), .CI(pc_call_c[13]), .O(pc_call_d[13]));
MUXCY muxcy_pc_call14(.S(pc_call_t[14]), .DI(pc_call_a[14]), .CI(pc_call_c[14]), .O(pc_call_c[14 + 1]));
XORCY xorcy_pc_call14(.LI(pc_call_t[14]), .CI(pc_call_c[14]), .O(pc_call_d[14]));
MUXCY muxcy_pc_call15(.S(pc_call_t[15]), .DI(pc_call_a[15]), .CI(pc_call_c[15]), .O());
XORCY xorcy_pc_call15(.LI(pc_call_t[15]), .CI(pc_call_c[15]), .O(pc_call_d[15]));
always @(posedge clk)
	if (valid & (w_rcall | w_icall | w_call)) pc_call <= pc_call_d;
LUT2 LUT2_pc_call0(.I1(iacc2), .I0(pcreg[0]), .O(pc_call_t[0]));
defparam LUT2_pc_call0.INIT = 6;
LUT2 LUT2_pc_call1(.I1(iacc2), .I0(pcreg[1]), .O(pc_call_t[1]));
defparam LUT2_pc_call1.INIT = 6;
LUT2 LUT2_pc_call2(.I1(iacc2), .I0(pcreg[2]), .O(pc_call_t[2]));
defparam LUT2_pc_call2.INIT = 6;
LUT2 LUT2_pc_call3(.I1(iacc2), .I0(pcreg[3]), .O(pc_call_t[3]));
defparam LUT2_pc_call3.INIT = 6;
LUT2 LUT2_pc_call4(.I1(iacc2), .I0(pcreg[4]), .O(pc_call_t[4]));
defparam LUT2_pc_call4.INIT = 6;
LUT2 LUT2_pc_call5(.I1(iacc2), .I0(pcreg[5]), .O(pc_call_t[5]));
defparam LUT2_pc_call5.INIT = 6;
LUT2 LUT2_pc_call6(.I1(iacc2), .I0(pcreg[6]), .O(pc_call_t[6]));
defparam LUT2_pc_call6.INIT = 6;
LUT2 LUT2_pc_call7(.I1(iacc2), .I0(pcreg[7]), .O(pc_call_t[7]));
defparam LUT2_pc_call7.INIT = 6;
LUT2 LUT2_pc_call8(.I1(iacc2), .I0(pcreg[8]), .O(pc_call_t[8]));
defparam LUT2_pc_call8.INIT = 6;
LUT2 LUT2_pc_call9(.I1(iacc2), .I0(pcreg[9]), .O(pc_call_t[9]));
defparam LUT2_pc_call9.INIT = 6;
LUT2 LUT2_pc_call10(.I1(iacc2), .I0(pcreg[10]), .O(pc_call_t[10]));
defparam LUT2_pc_call10.INIT = 6;
LUT2 LUT2_pc_call11(.I1(iacc2), .I0(pcreg[11]), .O(pc_call_t[11]));
defparam LUT2_pc_call11.INIT = 6;
LUT2 LUT2_pc_call12(.I1(iacc2), .I0(pcreg[12]), .O(pc_call_t[12]));
defparam LUT2_pc_call12.INIT = 6;
LUT2 LUT2_pc_call13(.I1(iacc2), .I0(pcreg[13]), .O(pc_call_t[13]));
defparam LUT2_pc_call13.INIT = 6;
LUT2 LUT2_pc_call14(.I1(iacc2), .I0(pcreg[14]), .O(pc_call_t[14]));
defparam LUT2_pc_call14.INIT = 6;
LUT2 LUT2_pc_call15(.I1(iacc2), .I0(pcreg[15]), .O(pc_call_t[15]));
defparam LUT2_pc_call15.INIT = 6;
`ifdef EPGM
wire load_eind;
FDE wb9(.C(clk), .CE(valid), .D(t_write & arb0 == 'h5c), .Q(load_eind));
reg [15-16:0] eind = 0;
always @(posedge clk) if (valid & load_eind) eind <= alu_y;
assign forward_eind = inst[4] ? load_eind ? alu_y : eind : 0;
assign data_out = sel8x4({ state[1] & i_call, ^state & i_call }, { pc_call, alu_wb });
`else
assign data_out = sel8x4({ state[1] & i_call, state[0] & i_call }, { pc_call, alu_wb });
`endif
assign adr = arb0;
assign spm_data = ra;
`ifdef TRACE
assign tracedata = {
	pc,				
	inst,			
	wadr,			
	data_out,		
	3'b000, we		
};
`endif
`ifdef DEBUG
wire [15+1:0] debug_pc = { pc, 1'b0 };
wire [15:0] debug_inst = { inst[7:0], inst[15:8] };
wire [4:0] debug_regadr = { regadr, 1'b0 };
reg [15:0] debug_adr = 0;
always @(posedge clk) if (valid) debug_adr <= arb0;
wire debug_wl = wreg & l_ce;
wire debug_wh = wreg & h_ce;
initial $monitor($stime,, "%x %x%x%x %x %x %x %x %x %x %x %x %x", 
	debug_pc, state, force_nop, sreg, debug_inst, 
	debug_regadr, wbdatal, debug_wl, wbdatah, debug_wh, debug_adr, data_out, we);
`endif
endmodule
